##########################################################################################
#Generating models
##########################################################################################
#Elastic test with a larger model and smoother reflector (10km width and 2km depth)
model_elastic_par_large= n1=201 d1=10.0 o1=0.0 n2=1001 d2=10.0 o2=0.0 n3=1 d3=10.0 o3=0.0

#True Elastic Vp
Vel/true_vp_ela_smooth_large.H:
	Vel ${model_elastic_par_large} vc=0.0 sin_period=150.0 sin_amp=30.0 sin_z=1600. sin_z_x0=0.0 sin_vel_up=0.0 sin_vel_down=200 > tmp.H
	Vel ${model_elastic_par_large} vc=1500.0 z1=300.0 vr1=2000. const1=1 vr2=2300. z2=700. const2=1 vr3=2500. z3=1200. const3=1 | Smooth rect1=6 > tmp1.H
	Add tmp.H tmp1.H > $@
	Rm tmp.H tmp1.H
#Background Elastic Vp
Vel/true_smooth_vp_ela_smooth_large.H:
	Vel ${model_elastic_par_large} vc=0.0 sin_period=150.0 sin_amp=30.0 sin_z=1600. sin_z_x0=0.0 sin_vel_up=0.0 sin_vel_down=200 | Smooth rect1=4 | Smooth rect2=4 repeat=3 > tmp.H
	Vel ${model_elastic_par_large} vc=1500.0 z1=300.0 vr1=2000. const1=1 vr2=2300. z2=700. const2=1 vr3=2500. z3=1200. const3=1 | Smooth rect1=6 > tmp1.H
	Add tmp.H tmp1.H > $@
	Rm tmp.H tmp1.H
	
#True Elastic Vs
Vel/true_vs_ela_smooth_large.H:
	Vel ${model_elastic_par_large} vc=0.0 sin_period=150.0 sin_amp=30.0 sin_z=1600. sin_z_x0=0.0 sin_vel_up=0.0 sin_vel_down=-150 > tmp.H
	Vel ${model_elastic_par_large} vc=0.0 z1=300.0 vr1=1250. const1=1 vr2=1500. z2=700. const2=1 vr3=1600. z3=1200. const3=1 | Smooth rect1=6 > tmp1.H
	Add tmp.H tmp1.H > $@
	Rm tmp.H tmp1.H
#Background Elastic Vs	
Vel/true_smooth_vs_ela_smooth_large.H:
	Vel ${model_elastic_par_large} vc=0.0 sin_period=150.0 sin_amp=30.0 sin_z=1600. sin_z_x0=0.0 sin_vel_up=0.0 sin_vel_down=-150 | Smooth rect1=4 repeat=3 | Smooth rect2=4 repeat=3 > tmp.H
	Vel ${model_elastic_par_large} vc=0.0 z1=300.0 vr1=1250. const1=1 vr2=1500. z2=700. const2=1 vr3=1600. z3=1200. const3=1 | Smooth rect1=6 > tmp1.H
	Add tmp.H tmp1.H > $@
	Rm tmp.H tmp1.H

#True Elastic Density
Vel/true_rho_ela_smooth_large.H:
	Vel ${model_elastic_par_large} vc=0.0 sin_period=150.0 sin_amp=30.0 sin_z=1600. sin_z_x0=0.0 sin_vel_up=0.0 sin_vel_down=-100 > tmp.H
	Vel ${model_elastic_par_large} vc=1000.0 z1=300.0 vr1=2000. const1=1 vr2=2150. z2=700. const2=1 vr3=2200. z3=1200. const3=1 | Smooth rect1=6 > tmp1.H
	Add tmp.H tmp1.H > $@
	Rm tmp.H tmp1.H
	
Vel/true_smooth_rho_ela_smooth_large.H:
	Vel ${model_elastic_par_large} vc=0.0 sin_period=150.0 sin_amp=30.0 sin_z=1600. sin_z_x0=0.0 sin_vel_up=0.0 sin_vel_down=-100 | Smooth rect1=4 repeat=3 | Smooth rect2=4 > tmp.H
	Vel ${model_elastic_par_large} vc=1000.0 z1=300.0 vr1=2000. const1=1 vr2=2150. z2=700. const2=1 vr3=2200. z3=1200. const3=1 | Smooth rect1=6 > tmp1.H
	Add tmp.H tmp1.H > $@
	Rm tmp.H tmp1.H
	
#Creating true elastic model	
Vel/true_ela_smooth_large.H: Vel/true_vp_ela_smooth_large.H Vel/true_vs_ela_smooth_large.H Vel/true_rho_ela_smooth_large.H
	Cat3d $^ axis=4 > $@
#Creating model with wiggly reflector smoothed
Vel/true_smooth_ela_smooth_large.H: Vel/true_smooth_vp_ela_smooth_large.H Vel/true_smooth_vs_ela_smooth_large.H Vel/true_smooth_rho_ela_smooth_large.H
	Cat3d $^ axis=4 > $@
	
#Acoustic model with smoothed true model for large model
Vel/true_smooth_vp_aco_smooth_large.H: Vel/true_smooth_vp_ela_smooth_large.H
	Add $< scale=1e-3 > $@
	echo "d1=0.01 d2=0.01 d3=0.01" >> $@
	
##########################################################################################
#Generating elastic data
##########################################################################################	
#Creating the wavelet
Wlt/wavelet_redatum_elastic_large.H: link-Wavelet.x
	${B}/Wavelet.x n1=4001 d1=0.004 w1=2 w2=5 w3=24 w4=30 tdelay=0.8 | Window n1=2000 | Pad end2=1 extend=1 | Pad end2=3 > $@	
	
#Acquisition geometry
#Source positions
${P}/sou_unif_elastic_large.p: Vel/true_vp_ela_smooth_large.H link-Geo_uniform.x
	Window3d < $< n2=1000 | ${B}/Geo_uniform.x depth=0. dx=100. file=$@ >/dev/null
#Receiver positions
${P}/rec_unif_elastic_large.p: Vel/true_vp_ela_smooth_large.H link-Geo_uniform.x
	${B}/Geo_uniform.x< $< depth=0. dx=10. file=$@ >/dev/null	
	
#Acquisition geometry
#Source positions very dense shots (every 20 meters)
${P}/sou_unif_elastic_large_20m.p: Vel/true_vp_ela_smooth_large.H link-Geo_uniform.x
	Window3d < $< n2=1000 | ${B}/Geo_uniform.x depth=0. dx=20. file=$@ >/dev/null
	
#Elastic data using true model
nshots_large=$(shell awk 'NR==2' Par/sou_unif_elastic_large.p | sed -e 's/^[ \t]*//')	
${D}/elastic_data_large.H: link-Propagator_elastic_fw.x Vel/true_ela_smooth_large.elastic_pad.H Wlt/wavelet_redatum_elastic_large.H ${P}/rec_unif_elastic_large.p ${P}/sou_unif_elastic_large.p	
# 	Rm wrk/true_large_ela-*.H
# 	rm -rf wrk/true_large_ela-*
	${B}/bte_elastic_fw.py pbs_template=${PBS_TMPL} queues=sep,default queues_cap=100,100 path_out=wrk prefix=true_large_ela nshots=${nshots_large} nshots_perjob=4 model=../Vel/true_ela_smooth_large.elastic_pad.H par_rec=../${P}/rec_unif_elastic_large.p par_sou=../${P}/sou_unif_elastic_large.p wavelet=../Wlt/wavelet_redatum_elastic_large.H threads=24 total_jobs_cap=24,400 mod_padded=1 mod_par=1 dt=1.0000000E-03 max_time=30m
	Cp wrk/true_large_ela-0-0.H $@
	${B}/Append $@ `ls wrk/true_large_ela-*.H | sort -V | sed 1d` virtual=1 axis=4
${D}/pressure-elastic_data_large.H: ${D}/elastic_data_large.H
	Window3d < $^ n2=2 | Stack3d | Add scale=0.5 >$@	
	

#Elastic data using true model for dense shot sampling
nshots_large_20m=$(shell awk 'NR==2' Par/sou_unif_elastic_large_20m.p | sed -e 's/^[ \t]*//')	
${D}/elastic_data_large_20m.H: link-Propagator_elastic_fw.x Vel/true_ela_smooth_large.elastic_pad.H Wlt/wavelet_redatum_elastic_large.H ${P}/rec_unif_elastic_large.p ${P}/sou_unif_elastic_large_20m.p	
# 	Rm wrk/true_large_ela-*.H
# 	rm -rf wrk/true_large_ela-*
	${B}/bte_elastic_fw.py pbs_template=${PBS_TMPL} queues=sep,default queues_cap=100,100 path_out=wrk prefix=true_20m_ela nshots=${nshots_large_20m} nshots_perjob=4 model=../Vel/true_ela_smooth_large.elastic_pad.H par_rec=../${P}/rec_unif_elastic_large.p par_sou=../${P}/sou_unif_elastic_large_20m.p wavelet=../Wlt/wavelet_redatum_elastic_large.H threads=24 total_jobs_cap=24,400 mod_padded=1 mod_par=1 dt=1.0000000E-03 max_time=30m
	Cp wrk/true_20m_ela-0-0.H $@
	${B}/Append $@ `ls wrk/true_20m_ela-*.H | sort -V | sed 1d` virtual=1 axis=4
${D}/pressure-elastic_data_large_20m.H: ${D}/elastic_data_large_20m.H
	Window3d < $^ n2=2 | Stack3d | Add scale=0.5 >$@	
	
#Elastic data using background model model
${D}/elastic_data_back_large.H: link-Propagator_elastic_fw.x Vel/true_smooth_ela_smooth_large.elastic_pad.H Wlt/wavelet_redatum_elastic_large.H ${P}/rec_unif_elastic_large.p ${P}/sou_unif_elastic_large.p	
# 	Rm wrk/bck_large_ela-*.H
# 	rm -rf wrk/bck_large_ela-*
	${B}/bte_elastic_fw.py pbs_template=${PBS_TMPL} queues=sep,default queues_cap=100,100 path_out=wrk prefix=bck_large_ela nshots=${nshots_large} nshots_perjob=1 model=../Vel/true_smooth_ela_smooth_large.elastic_pad.H par_rec=../${P}/rec_unif_elastic_large.p par_sou=../${P}/sou_unif_elastic_large.p wavelet=../Wlt/wavelet_redatum_elastic_large.H threads=24 total_jobs_cap=24,300 mod_padded=1 mod_par=1 dt=1.0000000E-03
	Cp wrk/bck_large_ela-0-0.H $@
	${B}/Append $@ `ls wrk/bck_large_ela-*.H | sort -V | sed 1d` virtual=1 axis=4
${D}/pressure-elastic_data_back_large.H: ${D}/elastic_data_back_large.H
	Window3d < $^ n2=2 | Stack3d | Add scale=0.5 >$@
	
#Elastic data using background model model for dense shot sampling
${D}/elastic_data_back_large_20m.H: link-Propagator_elastic_fw.x Vel/true_smooth_ela_smooth_large.elastic_pad.H Wlt/wavelet_redatum_elastic_large.H ${P}/rec_unif_elastic_large.p ${P}/sou_unif_elastic_large_20m.p	
# 	Rm wrk/bck_large_ela-*.H
# 	rm -rf wrk/bck_large_ela-*
	${B}/bte_elastic_fw.py pbs_template=${PBS_TMPL} queues=sep,default queues_cap=100,100 path_out=wrk prefix=bck_20m_ela nshots=${nshots_large_20m} nshots_perjob=4 model=../Vel/true_smooth_ela_smooth_large.elastic_pad.H par_rec=../${P}/rec_unif_elastic_large.p par_sou=../${P}/sou_unif_elastic_large_20m.p wavelet=../Wlt/wavelet_redatum_elastic_large.H threads=24 total_jobs_cap=24,300 mod_padded=1 mod_par=1 dt=1.0000000E-03
	Cp wrk/bck_20m_ela-0-0.H $@
	${B}/Append $@ `ls wrk/bck_20m_ela-*.H | sort -V | sed 1d` virtual=1 axis=4
${D}/pressure-elastic_data_back_large_20m.H: ${D}/elastic_data_back_large_20m.H
	Window3d < $^ n2=2 | Stack3d | Add scale=0.5 >$@
	
##########################################################################################
#Extended migration
##########################################################################################	
Wlt/wavelet_redatum_acoustic_large.H: Wlt/wavelet_redatum_elastic_large.H link-Deriv1ord_1th.x
	Window3d < $< n2=1 | Interp d1out=1e-3 type=2 lsinc=20 | ${B}/Deriv1ord_1th.x | Interp d1out=4e-3 | Pad n1=`Get <$< n1 parform=n` > junk_tmp.H
	#Scaling 1/(1.5*1.5) and 1/(10*10)
	Add scale=0.4444444444444444 junk_tmp.H | Add scale=1e-2 >$@
	Rm junk_tmp.H 	
	
#Inversion mask
Vel/mask_ela_extended_large.H: Vel/true_smooth_vp_aco_smooth_large.acoustic_pad.H
	Math file1=$< exp='file1*0.0+1.0' | Window3d min1=1.4 | Pad beg1=340 | Pad n4=161 extend=1 | Smooth rect1=4 >$@
	echo "d4=0.01 o4=-0.8">>$@
#Non-extended
Vel/mask_ela_large.H: Vel/true_smooth_vp_aco_smooth_large.acoustic_pad.H
	Math file1=$< exp='file1*0.0+1.0' | Window3d min1=1.4 | Pad beg1=340 | Smooth rect1=4 >$@
	echo "d4=0.01 o4=-0.8">>$@
#Initial extended model
Vel/initial_dm_ext_aco_large.pad.H: Vel/true_smooth_vp_aco_smooth_large.acoustic_pad.H
	Add $^ scale=0.0 > tmp.H
	echo "n4=1 d4=0.01 o4=0.0 n5=1 d5=0.004 o5=0.0 n6=1 d6=0.04 o6=0.0" >> tmp.H
	Pad beg4=80 end4=80 < tmp.H > $@
	Rm tmp.H
#non-extended
Vel/initial_dm_aco_large.pad.H: Vel/true_smooth_vp_aco_smooth_large.acoustic_pad.H
	Add $^ scale=0.0 > $@
	echo "n4=1 d4=0.01 o4=0.0 n5=1 d5=0.004 o5=0.0 n6=1 d6=0.04 o6=0.0" >> $@

#Data residuals (elastic)
${D}/elastic_residuals_large.H: ${D}/pressure-elastic_data_large.H ${D}/pressure-elastic_data_back_large.H
	Add $^ scale=1,-1 >$@	

#Data residuals (elastic) with 20m shot spacing
${D}/elastic_residuals_large_20m.H: ${D}/pressure-elastic_data_large_20m.H ${D}/pressure-elastic_data_back_large_20m.H
	Add $^ scale=1,-1 >$@
	
#Running extended acoustic migration with elastic data (sub-surface offsets) with a mask for 10km model (used smoothed vp model)
ela_bornhx_inv_mask_large: solver_prog ${D}/elastic_residuals_large.H Vel/true_smooth_vp_aco_smooth_large.acoustic_pad.H Vel/initial_dm_ext_aco_large.pad.H Wlt/wavelet_redatum_acoustic_large.H Vel/mask_ela_extended_large.H
	${B}/lin_solver.py fwd_cmd_file=${P}/ela_bornhx_inv_mask_large.fwd.p adj_cmd_file=${P}/ela_bornhx_inv_mask_large.adj.p data=${D}/elastic_residuals_large.H init_model=Vel/initial_dm_ext_aco_large.pad.H inv_model=ela_born_ext_hx_mask_large.invmod.H suffix=ela_born_ext_hx_mask_large iteration_movies=obj,model,residual,gradient niter=200 wrk_dir=ElaBornHxMaskLarge debug=y
	
#Running extended acoustic migration with elastic data (sub-surface offsets) with a mask for 10km model (used smoothed vp model) and 20m shot spacing
ela_bornhx_inv_mask_large_20m: solver_prog ${D}/elastic_residuals_large_20m.H Vel/true_smooth_vp_aco_smooth_large.acoustic_pad.H Vel/initial_dm_ext_aco_large.pad.H Wlt/wavelet_redatum_acoustic_large.H Vel/mask_ela_extended_large.H
	${B}/lin_solver.py fwd_cmd_file=${P}/ela_bornhx_inv_mask_large_20m.fwd.p adj_cmd_file=${P}/ela_bornhx_inv_mask_large_20m.adj.p data=${D}/elastic_residuals_large_20m.H init_model=Vel/initial_dm_ext_aco_large.pad.H inv_model=ela_born_ext_hx_mask_large_20m.invmod.H suffix=ela_born_ext_hx_mask_large_20m iteration_movies=obj,model,residual,gradient niter=200 wrk_dir=ElaBornHxMaskLarge20m
	
#Running extended acoustic migration with elastic data (non-extended) with a mask for 10km model (used smoothed vp model)
ela_born_inv_mask_large: solver_prog ${D}/elastic_residuals_large.H Vel/true_smooth_vp_aco_smooth_large.acoustic_pad.H Vel/initial_dm_aco_large.pad.H Wlt/wavelet_redatum_acoustic_large.H Vel/mask_ela_large.H
	${B}/lin_solver.py fwd_cmd_file=${P}/ela_born_inv_mask_large.fwd.p adj_cmd_file=${P}/ela_born_inv_mask_large.adj.p data=${D}/elastic_residuals_large.H init_model=Vel/initial_dm_aco_large.pad.H inv_model=ela_born_mask_large.invmod.H suffix=ela_born_mask_large iteration_movies=obj,model,residual,gradient niter=200 wrk_dir=ElaBornMaskLarge
	
#Running extended acoustic migration with elastic data (sub-surface offsets) with a mask for 10km model (used smoothed vp model) with dso
#Epsilon balancing the data-space gradients is: 4.17583422914e-05
ela_bornhx_inv_mask_large_dso: solver_prog ${D}/elastic_residuals_large.H Vel/true_smooth_vp_aco_smooth_large.acoustic_pad.H Vel/initial_dm_ext_aco_large.pad.H Wlt/wavelet_redatum_acoustic_large.H Vel/mask_ela_extended_large.H
	${B}/lin_solver.py fwd_cmd_file=${P}/ela_bornhx_inv_mask_large.fwd.p adj_cmd_file=${P}/ela_bornhx_inv_mask_large.adj.p data=${D}/elastic_residuals_large.H init_model=Vel/initial_dm_ext_aco_large.pad.H inv_model=ela_born_ext_hx_mask_large_dso.invmod.H suffix=ela_born_ext_hx_mask_large_dso iteration_movies=obj,model,residual,gradient niter=200 wrk_dir=ElaBornHxMaskLargeDso fwd_cmd_reg_file=${P}/ela_bornhx_inv_mask_box_large.dso.fwd.p adj_cmd_reg_file=${P}/ela_bornhx_inv_mask_box_large.dso.fwd.p epsilon=2.e-06
	
#Running extended acoustic migration with elastic data (sub-surface offsets) with a mask for 10km model (used smoothed vp model)
ela_bornhx_inv_mask_large_scale: solver_prog ${D}/elastic_residuals_large.H Vel/true_smooth_vp_aco_smooth_large.acoustic_pad.H Vel/initial_dm_ext_aco_large.pad.H Wlt/wavelet_redatum_acoustic_large.H Vel/mask_ela_extended_large.H
	Add ${D}/elastic_residuals_large.H scale=1e7 > ${D}/elastic_residuals_large_scale.H
	Add Wlt/wavelet_redatum_acoustic_large.H scale=1e7 > Wlt/wavelet_redatum_acoustic_large_scale.H
	${B}/lin_solver.py fwd_cmd_file=${P}/ela_bornhx_inv_mask_large_scale.fwd.p adj_cmd_file=${P}/ela_bornhx_inv_mask_large_scale.adj.p data=${D}/elastic_residuals_large_scale.H init_model=Vel/initial_dm_ext_aco_large.pad.H inv_model=ela_born_ext_hx_mask_large_scale.invmod.H suffix=ela_born_ext_hx_mask_large_scale iteration_movies=obj,model,residual,gradient niter=200 wrk_dir=ElaBornHxMaskLargeScale debug=y restart=y
	Rm ${D}/elastic_residuals_large_scale.H Wlt/wavelet_redatum_acoustic_large_scale.H

ela_bornhx_inv_mask_large_cont: solver_prog ${D}/elastic_residuals_large.H Vel/true_smooth_vp_aco_smooth_large.acoustic_pad.H Vel/initial_dm_ext_aco_large.pad.H Wlt/wavelet_redatum_acoustic_large.H Vel/mask_ela_extended_large.H
	${B}/lin_solver.py fwd_cmd_file=${P}/ela_bornhx_inv_mask_large.fwd.p adj_cmd_file=${P}/ela_bornhx_inv_mask_large.adj.p data=${D}/elastic_residuals_large.H init_model=Vel/initial_dm_ext_aco_large.pad.H inv_model=ela_born_ext_hx_mask_large_cont.invmod.H suffix=ela_born_ext_hx_mask_large_cont iteration_movies=obj,model,residual,gradient niter=200 wrk_dir=ElaBornHxMaskLargeCont debug=y

#Running extended acoustic migration with elastic data (sub-surface offsets) with a mask for 10km model (used smoothed vp model)
ela_bornhx_inv_nomask_large: solver_prog ${D}/elastic_residuals_large.H Vel/true_smooth_vp_aco_smooth_large.acoustic_pad.H Vel/initial_dm_ext_aco_large.pad.H Wlt/wavelet_redatum_acoustic_large.H
	${B}/lin_solver.py fwd_cmd_file=${P}/ela_bornhx_inv_nomask_large.fwd.p adj_cmd_file=${P}/ela_bornhx_inv_nomask_large.adj.p data=${D}/elastic_residuals_large.H init_model=Vel/initial_dm_ext_aco_large.pad.H inv_model=ela_born_ext_hx_nomask_large.invmod.H suffix=ela_born_ext_hx_nomask_large iteration_movies=obj,model,residual,gradient niter=200 wrk_dir=ElaBornHxNoMaskLarge debug=y restart=y
		
	
#Running extended acoustic migration with elastic data (sub-surface offsets) with a mask for 10km model (used smoothed vp model) with dipole
ela_bornhx_inv_mask_large_dipole: solver_prog ${D}/elastic_residuals_large.H Vel/true_smooth_vp_aco_smooth_large.acoustic_pad.H Vel/initial_dm_ext_aco_large.pad.H Wlt/wavelet_redatum_acoustic_large.H Vel/mask_ela_extended_large.H
	${B}/lin_solver.py fwd_cmd_file=${P}/ela_bornhx_inv_mask_large_dipole.fwd.p adj_cmd_file=${P}/ela_bornhx_inv_mask_large_dipole.adj.p data=${D}/elastic_residuals_large.H init_model=Vel/initial_dm_ext_aco_large.pad.H inv_model=ela_born_ext_hx_mask_large_dipole.invmod.H suffix=ela_born_ext_hx_mask_large_dipole iteration_movies=obj,model,residual,gradient niter=200 wrk_dir=ElaBornHxMaskLargeDipole debug=y
	
#Running extended acoustic migration with elastic data (sub-surface offsets) with a mask for 10km model (used smoothed vp model) with dipole
ela_bornhx_inv_nomask_large_dipole: solver_prog ${D}/elastic_residuals_large.H Vel/true_smooth_vp_aco_smooth_large.acoustic_pad.H Vel/initial_dm_ext_aco_large.pad.H Wlt/wavelet_redatum_acoustic_large.H
	${B}/lin_solver.py fwd_cmd_file=${P}/ela_bornhx_inv_nomask_large_dipole.fwd.p adj_cmd_file=${P}/ela_bornhx_inv_nomask_large_dipole.adj.p data=${D}/elastic_residuals_large.H init_model=Vel/initial_dm_ext_aco_large.pad.H inv_model=ela_born_ext_hx_nomask_large_dipole.invmod.H suffix=ela_born_ext_hx_nomask_large_dipole iteration_movies=obj,model,residual,gradient niter=200 wrk_dir=ElaBornHxNoMaskLargeDipole debug=y

##########################################################################################
#Data reconstruction within last layer
##########################################################################################
#Creating true elastic model within box (smooth reflectors)
Vel/true_ela_smooth_box_large.H: Vel/true_ela_smooth_large.H
	Window3d < $< min1=1200 squeeze=0 > $@
#Creating background elastic model within box (smooth reflectors)
Vel/true_smooth_ela_smooth_box_large.H: Vel/true_smooth_ela_smooth_large.H
	Window3d < $< min1=1200 squeeze=0 > $@
#Creating background acoustic model within box (smooth reflectors)
Vel/true_smooth_vp_aco_smooth_box_large.H: Vel/true_smooth_vp_aco_smooth_large.H
	Window3d < $< min1=1.2 squeeze=0 > $@
#Creating the wavelet
Wlt/wavelet_redatum_elastic_large_box.H: link-Wavelet.x
	${B}/Wavelet.x n1=4001 d1=0.004 w1=2 w2=5 w3=24 w4=30 tdelay=0.8 | Window n1=1500 | Pad end2=1 extend=1 | Pad end2=3 > $@
#Acoustic wavelet
Wlt/wavelet_redatum_acoustic_large_box.H: Wlt/wavelet_redatum_elastic_large_box.H link-Deriv1ord_1th.x
	Window3d < $< n2=1 | Interp d1out=1e-3 type=2 lsinc=20 | ${B}/Deriv1ord_1th.x | Interp d1out=4e-3 | Pad n1=`Get <$< n1 parform=n` > junk_tmp.H
	#Scaling 1/(1.5*1.5) and 1/(10*10)
	Add scale=0.17156201125999154 junk_tmp.H | Add scale=1e-2 >$@
	Rm junk_tmp.H 	


#Acquisition geometry
#Source positions
${P}/sou_unif_elastic_box_large.p: Vel/true_ela_smooth_box_large.H link-Geo_uniform.x
	Window3d < $< n2=1000 n4=1| ${B}/Geo_uniform.x depth=1200. dx=100. file=$@ >/dev/null
#Receiver positions
${P}/rec_unif_elastic_box_large.p: Vel/true_ela_smooth_box_large.H link-Geo_uniform.x
	Window3d < $< n4=1 | ${B}/Geo_uniform.x depth=1200. dx=10. file=$@ >/dev/null

#Creating data within last layer
#Elastic data using true model
nshots_large_box=$(shell awk 'NR==2' Par/sou_unif_elastic_box_large.p | sed -e 's/^[ \t]*//')	
${D}/elastic_data_box_large.H: link-Propagator_elastic_fw.x Vel/true_ela_smooth_box_large.elastic_pad.H Wlt/wavelet_redatum_elastic_large_box.H ${P}/rec_unif_elastic_box_large.p ${P}/sou_unif_elastic_box_large.p	
	Rm wrk/box_large_ela-*.H
	rm -rf wrk/box_large_ela-*
	${B}/bte_elastic_fw.py pbs_template=${PBS_TMPL} queues=sep,default queues_cap=100,100 path_out=wrk prefix=box_large_ela nshots=${nshots_large_box} nshots_perjob=1 model=../Vel/true_ela_smooth_box_large.elastic_pad.H par_rec=../${P}/rec_unif_elastic_box_large.p par_sou=../${P}/sou_unif_elastic_box_large.p wavelet=../Wlt/wavelet_redatum_elastic_large_box.H threads=24 total_jobs_cap=24,200 mod_padded=1 mod_par=1 dt=1.0000000E-03
	cp wrk/box_large_ela-0-0.H $@
	${B}/Append $@ `ls wrk/box_large_ela-*.H | sort -V | sed 1d` virtual=1 axis=4
${D}/pressure-elastic_data_box_large.H: ${D}/elastic_data_box_large.H
	Window3d < $^ n2=2 | Stack3d | Add scale=0.5 >$@
#Elastic data using background model
${D}/elastic_data_back_box_large.H: link-Propagator_elastic_fw.x Vel/true_smooth_ela_smooth_box_large.elastic_pad.H Wlt/wavelet_redatum_elastic_large_box.H ${P}/rec_unif_elastic_box_large.p ${P}/sou_unif_elastic_box_large.p	
	Rm wrk/box_lbck_ela-*.H
	rm -rf wrk/box_lbck_ela-*
	${B}/bte_elastic_fw.py pbs_template=${PBS_TMPL} queues=sep,default queues_cap=100,100 path_out=wrk prefix=box_lbck_ela nshots=${nshots_large_box} nshots_perjob=1 model=../Vel/true_smooth_ela_smooth_box_large.elastic_pad.H par_rec=../${P}/rec_unif_elastic_box_large.p par_sou=../${P}/sou_unif_elastic_box_large.p wavelet=../Wlt/wavelet_redatum_elastic_large_box.H threads=24 total_jobs_cap=24,200 mod_padded=1 mod_par=1 dt=1.0000000E-03
	cp wrk/box_lbck_ela-0-0.H $@
	${B}/Append $@ `ls wrk/box_lbck_ela-*.H | sort -V | sed 1d` virtual=1 axis=4
${D}/pressure-elastic_data_back_box_large.H: ${D}/elastic_data_back_box_large.H
	Window3d < $^ n2=2 | Stack3d | Add scale=0.5 >$@

#Data residuals (elastic) within the box
${D}/elastic_residuals_box_large.H: ${D}/pressure-elastic_data_box_large.H ${D}/pressure-elastic_data_back_box_large.H
	Add $^ scale=1,-1 >$@	

#Initial extended perturbation within the box
Vel/initial_dm_ext_aco_box_large.pad.H: Vel/initial_dm_ext_aco_large.pad.H
	Window3d < $< min1=1.2 squeeze=0 | Pad beg1=200 > $@
#Inversion mask within the box
Vel/mask_ela_extended_box_large.H: Vel/mask_ela_extended_large.H
	Window3d < $< min1=1.2 squeeze=0 | Pad beg1=200 > $@

#Running extended acoustic migration with elastic data (sub-surface offsets) with a mask for boxed model (using smoothed reflector background).
ela_bornhx_inv_mask_box_large: solver_prog ${D}/elastic_residuals_box_large.H Vel/true_smooth_vp_aco_smooth_box_large.acoustic_pad.H Vel/initial_dm_ext_aco_box_large.pad.H Wlt/wavelet_redatum_acoustic_large_box.H Vel/mask_ela_extended_box_large.H
	${B}/lin_solver.py fwd_cmd_file=${P}/ela_bornhx_inv_mask_box_large.fwd.p adj_cmd_file=${P}/ela_bornhx_inv_mask_box_large.adj.p data=${D}/elastic_residuals_box_large.H init_model=Vel/initial_dm_ext_aco_box_large.pad.H inv_model=ela_born_ext_hx_mask_box_large.invmod.H suffix=ela_born_ext_hx_mask_box_large iteration_movies=obj,model,residual niter=200 wrk_dir=ElaBornHxMaskBoxLarge 
	
#Running extended acoustic migration with elastic data (sub-surface offsets) with a mask for boxed model (using smoothed reflector background) adding DSO term to make gather more focus
#Epsilon balancing the data-space gradients is: 9.68830366196e-05; Trying 0.05*9.68830366196e-05
ela_bornhx_inv_mask_box_large_dso: solver_prog ${D}/elastic_residuals_box_large.H Vel/true_smooth_vp_aco_smooth_box_large.acoustic_pad.H Vel/initial_dm_ext_aco_box_large.pad.H Wlt/wavelet_redatum_acoustic_large_box.H Vel/mask_ela_extended_box_large.H
	${B}/lin_solver.py fwd_cmd_file=${P}/ela_bornhx_inv_mask_box_large.fwd.p adj_cmd_file=${P}/ela_bornhx_inv_mask_box_large.adj.p data=${D}/elastic_residuals_box_large.H init_model=Vel/initial_dm_ext_aco_box_large.pad.H inv_model=ela_born_ext_hx_mask_box_large_dso.invmod.H suffix=ela_born_ext_hx_mask_box_large_dso iteration_movies=obj,model,residual niter=200 wrk_dir=ElaBornHxMaskBoxLargeDso fwd_cmd_reg_file=${P}/ela_bornhx_inv_mask_box_large.dso.fwd.p adj_cmd_reg_file=${P}/ela_bornhx_inv_mask_box_large.dso.fwd.p epsilon=4.84415183098e-06
	
#Running extended acoustic migration with elastic data (sub-surface offsets) without a mask for boxed model (using smoothed reflector background).
ela_bornhx_inv_nomask_box_large: solver_prog ${D}/elastic_residuals_box_large.H Vel/true_smooth_vp_aco_smooth_box_large.acoustic_pad.H Vel/initial_dm_ext_aco_box_large.pad.H Wlt/wavelet_redatum_acoustic_large_box.H
	${B}/lin_solver.py fwd_cmd_file=${P}/ela_bornhx_inv_nomask_box_large.fwd.p adj_cmd_file=${P}/ela_bornhx_inv_nomask_box_large.adj.p data=${D}/elastic_residuals_box_large.H init_model=Vel/initial_dm_ext_aco_box_large.pad.H inv_model=ela_born_ext_hx_nomask_box_large.invmod.H suffix=ela_born_ext_hx_nomask_box_large iteration_movies=obj,model,residual niter=200 wrk_dir=ElaBornHxNoMaskBoxLarge debug=y
	
#########################################	
#Comparing angle domain CIGs
#ElaBornHxNoMaskBoxLarge/modelela_born_ext_hx_nomask_box_large.H f5=31 | Window3d n2=1 min2=5 min1=0.8 max1=2.5 max2=10
#ElaBornHxMaskLarge/modelela_born_ext_hx_mask_large.H n2=1 min2=5 n5=1 f5=70 min1=0.8 max1=2.5 min2=0.8 max2=10

#Angle domain
surf_CIG_angle.H: 
	Window3d <ElaBornHxMaskLarge/ela_born_ext_hx_mask_large.invmod.H min1=1.2 n1=250 min2=5 n2=2 | Pad end1=262 | Rtoc | Ft3d sign1=1 | Transp plane=13 | Transp plane=24 >tmp_fft_$@
	${B}/Off2Ang.x <tmp_fft_$@ par=${P}/ang_spike.p Coplanar_azim_ang=tmp_fft_ang_$@ >$@.head 2>$@.log
	Window3d <tmp_fft_ang_$@ | Ft3d sign2=-1 sign3=0 maxsize=2000 | Real | Window3d n2=250 | Transp plane=12 maxsize=2000 >$@
	Rm tmp_*_$@

sunk_CIG_angle.H: 
	Window3d <ElaBornHxNoMaskBoxLarge/modelela_born_ext_hx_nomask_box_large.H min1=1.2 n1=250 min2=5 n2=2 f5=31 n5=1| Pad end1=262 | Rtoc | Ft3d sign1=1 | Transp plane=13 | Transp plane=24 >tmp_fft_$@
	${B}/Off2Ang.x <tmp_fft_$@ par=${P}/ang_spike.p Coplanar_azim_ang=tmp_fft_ang_$@ >$@.head 2>$@.log
	Window3d <tmp_fft_ang_$@ | Ft3d sign2=-1 sign3=0 maxsize=2000 | Real | Window3d n2=250 | Transp plane=12 maxsize=2000 >$@
	Rm tmp_*_$@ #ElaBornHxMaskLarge20m/ela_born_ext_hx_mask_large_20m.invmod.H 
	
surf20m_CIG_angle.H: 
	Window3d <ElaBornHxMaskLarge20m/ela_born_ext_hx_mask_large_20m.invmod.H  min1=1.2 n1=250 min2=5 n2=2 | Pad end1=262 | Rtoc | Ft3d sign1=1 | Transp plane=13 | Transp plane=24 >tmp_fft_$@
	${B}/Off2Ang.x <tmp_fft_$@ par=${P}/ang_spike.p Coplanar_azim_ang=tmp_fft_ang_$@ >$@.head 2>$@.log
	Window3d <tmp_fft_ang_$@ | Ft3d sign2=-1 sign3=0 maxsize=2000 | Real | Window3d n2=250 | Transp plane=12 maxsize=2000 >$@
	Rm tmp_*_$@ 

#########################################	
#Running with data only between 2 to 8 km
#Data residuals (elastic)
${D}/elastic_residuals_box_large_cut.H: ${D}/elastic_residuals_box_large.H
	Window3d f2=200 n2=600 f3=20 n3=60 < $< > $@
#Initial extended perturbation within the box
Vel/initial_dm_ext_aco_box_large_cut.pad.H: Vel/initial_dm_ext_aco_large.pad.H
	Window3d < $< min1=1.2 min2=2.0 max2=8.0 squeeze=0 | Pad beg1=200 beg2=200 end2=200 > $@
#Inversion mask within the box
Vel/mask_ela_extended_box_large_cut.H: Vel/mask_ela_extended_large.H
	Window3d < $< min1=1.2 min2=2.0 max2=8.0 squeeze=0 | Pad beg1=200 | Pad extend=1 beg2=200 end2=200 > $@
#Creating background acoustic model within box (smooth reflectors)
Vel/true_smooth_vp_aco_smooth_box_large_cut.H: Vel/true_smooth_vp_aco_smooth_large.H
	Window3d < $< min1=1.2 min2=2.0 max2=8.0 squeeze=0 > $@
	
#Running extended acoustic migration with elastic data (sub-surface offsets) with a mask for boxed model (using smoothed reflector background).
ela_bornhx_inv_mask_box_large_cut: solver_prog ${D}/elastic_residuals_box_large_cut.H Vel/true_smooth_vp_aco_smooth_box_large_cut.acoustic_pad.H Vel/initial_dm_ext_aco_box_large_cut.pad.H Wlt/wavelet_redatum_acoustic_large_box.H Vel/mask_ela_extended_box_large_cut.H
	${B}/lin_solver.py fwd_cmd_file=${P}/ela_bornhx_inv_mask_box_large_8km.fwd.p adj_cmd_file=${P}/ela_bornhx_inv_mask_box_large_8km.adj.p data=${D}/elastic_residuals_box_large_cut.H init_model=Vel/initial_dm_ext_aco_box_large_cut.pad.H inv_model=ela_born_ext_hx_mask_box_large_8km.invmod.H suffix=ela_born_ext_hx_mask_box_large_8km iteration_movies=obj,model,residual niter=200 wrk_dir=ElaBornHxMaskBoxLarge8km 
	
#Running extended acoustic migration with elastic data (sub-surface offsets) without a mask for boxed model (using smoothed reflector background).
ela_bornhx_inv_nomask_box_large_cut: solver_prog ${D}/elastic_residuals_box_large_cut.H Vel/true_smooth_vp_aco_smooth_box_large_cut.acoustic_pad.H Vel/initial_dm_ext_aco_box_large_cut.pad.H Wlt/wavelet_redatum_acoustic_large_box.H Vel/mask_ela_extended_box_large_cut.H
	${B}/lin_solver.py fwd_cmd_file=${P}/ela_bornhx_inv_nomask_box_large_8km.fwd.p adj_cmd_file=${P}/ela_bornhx_inv_nomask_box_large_8km.adj.p data=${D}/elastic_residuals_box_large_cut.H init_model=Vel/initial_dm_ext_aco_box_large_cut.pad.H inv_model=ela_born_ext_hx_nomask_box_large_8km.invmod.H suffix=ela_born_ext_hx_nomask_box_large_8km iteration_movies=obj,model,residual niter=200 wrk_dir=ElaBornHxNoMaskBoxLarge8km 
	
#Running extended acoustic migration with elastic data (sub-surface offsets) without a mask for boxed model (using smoothed reflector background) dipole.
ela_bornhx_inv_nomask_box_large_cut_dipole: solver_prog ${D}/elastic_residuals_box_large_cut.H Vel/true_smooth_vp_aco_smooth_box_large_cut.acoustic_pad.H Vel/initial_dm_ext_aco_box_large_cut.pad.H Wlt/wavelet_redatum_acoustic_large_box.H Vel/mask_ela_extended_box_large_cut.H
	${B}/lin_solver.py fwd_cmd_file=${P}/ela_bornhx_inv_nomask_box_large_8km_dipole.fwd.p adj_cmd_file=${P}/ela_bornhx_inv_nomask_box_large_8km_dipole.adj.p data=${D}/elastic_residuals_box_large_cut.H init_model=Vel/initial_dm_ext_aco_box_large_cut.pad.H inv_model=ela_born_ext_hx_nomask_box_large_8km_dipole.invmod.H suffix=ela_born_ext_hx_nomask_box_large_8km_dipole iteration_movies=obj,model,residual niter=200 wrk_dir=ElaBornHxNoMaskBoxLarge8kmDipole
#########################################

#Extended scattering when buried acquisition geometry but data inverted from smooth layers (!!!!using background vp acoustic model!!!!)
Vel/mask_elastic_scat_dat_large.H: Vel/initial_dm_ext_aco_large.pad.H
	Window3d < $< min1=1.35 max1=1.8 min4=-0.2 max4=0.21 > tmp_mask.H
	Math file1=tmp_mask.H exp="file1*0.0+1.0" | Pad beg1=335 end1=221 beg3=60 end3=60 | Smooth rect1=4 rect2=4 rect3=4 | Transp plane=34 > $@
	Rm tmp_mask.H
	
#Strong mask to try to remove artifacts
Vel/mask_elastic_scat_dat_large_strong.H: Vel/initial_dm_ext_aco_large.pad.H
	Window3d < $< min1=1.5 max1=1.8 min4=-0.2 max4=0.21 > tmp_mask.H
	Math file1=tmp_mask.H exp="file1*0.0+1.0" | Pad beg1=350 end1=221 beg3=60 end3=60 | Smooth rect1=4 rect2=4 rect3=4 | Transp plane=34 > $@
	Rm tmp_mask.H

#Mask no dipole
${D}/ela_scat_data_box_back_large.H: Vel/true_smooth_vp_aco_smooth_box_large.acoustic_pad.H Wlt/wavelet_redatum_acoustic_large_box.H Vel/mask_elastic_scat_dat.H #ela_bornhx_inv_mask_smooth
	Math file1=ElaBornHxMaskLarge/ela_born_ext_hx_mask_large.invmod.H file2=Vel/mask_elastic_scat_dat_large.H exp="file1*file2" | Window3d min1=1.2 squeeze=0 | Pad beg1=200 > temp_pert_elahx_box_large_smooth.H
	${SCRIPTDIR}/batch_task_executor_ext_born_fwd.py pbs_template=${PBS_TMPL} os=101 nshots=${nshots_large_box} nshotjob=2 ds=10 model=../temp_pert_elahx_box_large_smooth.H vel=../Vel/true_smooth_vp_aco_smooth_box_large.acoustic_pad.H hzmax=0 hxmax=80 htmax=0 par=../Par/ela.box.inv.10km.fwd.p queues=sep,default queues_cap=30,30 path_out=wrk prefix=elabornlabo total_jobs_cap=24,300
	#Scaling of the source wavelet (need to understand additional scaling factor)
	Add elabornlabo-final.H scale=0.386014525334981 | Add scale=1.9159165294586593 > $@
	Rm temp_pert_elahx_box_large_smooth.H elabornlabo-final.H

#Mask no dipole strong mask
${D}/ela_scat_data_box_back_large_strong.H: Vel/true_smooth_vp_aco_smooth_box_large.acoustic_pad.H Wlt/wavelet_redatum_acoustic_large_box.H Vel/mask_elastic_scat_dat_large_strong.H #ela_bornhx_inv_mask_smooth
	Math file1=ElaBornHxMaskLarge/ela_born_ext_hx_mask_large.invmod.H file2=Vel/mask_elastic_scat_dat_large_strong.H exp="file1*file2" | Window3d min1=1.2 squeeze=0 | Pad beg1=200 > temp_pert_elahx_box_large_smooth_strong.H
	${SCRIPTDIR}/batch_task_executor_ext_born_fwd.py pbs_template=${PBS_TMPL} os=101 nshots=${nshots_large_box} nshotjob=2 ds=10 model=../temp_pert_elahx_box_large_smooth_strong.H vel=../Vel/true_smooth_vp_aco_smooth_box_large.acoustic_pad.H hzmax=0 hxmax=80 htmax=0 par=../Par/ela.box.inv.10km.fwd.p queues=sep,default queues_cap=30,30 path_out=wrk prefix=elabornsto total_jobs_cap=24,300
	#Scaling of the source wavelet (need to understand additional scaling factor)
	Add elabornsto-final.H scale=0.386014525334981 | Add scale=1.9159165294586593 > $@
	Rm temp_pert_elahx_box_large_smooth_strong.H elabornsto-final.H

#Mask no dipole strong mask 20m
${D}/ela_scat_data_box_back_large_strong20m.H: Vel/true_smooth_vp_aco_smooth_box_large.acoustic_pad.H Wlt/wavelet_redatum_acoustic_large_box.H Vel/mask_elastic_scat_dat_large_strong.H #ela_bornhx_inv_mask_smooth
	Math file1=ElaBornHxMaskLarge20m/ela_born_ext_hx_mask_large_20m.invmod.H file2=Vel/mask_elastic_scat_dat_large_strong.H exp="file1*file2" | Window3d min1=1.2 squeeze=0 | Pad beg1=200 > temp_pert_elahx_box_large_smooth_strong20m.H
	${SCRIPTDIR}/batch_task_executor_ext_born_fwd.py pbs_template=${PBS_TMPL} os=101 nshots=${nshots_large_box} nshotjob=2 ds=10 model=../temp_pert_elahx_box_large_smooth_strong20m.H vel=../Vel/true_smooth_vp_aco_smooth_box_large.acoustic_pad.H hzmax=0 hxmax=80 htmax=0 par=../Par/ela.box.inv.10km.fwd.p queues=sep,default queues_cap=30,30 path_out=wrk prefix=elaborn20m total_jobs_cap=24,300
	#Scaling of the source wavelet (need to understand additional scaling factor)
	Add elaborn20m-final.H scale=0.386014525334981 | Add scale=1.9159165294586593 > $@
	Rm temp_pert_elahx_box_large_smooth_strong20m.H elaborn20m-final.H
	
#Mask no dipole 20m
${D}/ela_scat_data_box_back_large20m.H: Vel/true_smooth_vp_aco_smooth_box_large.acoustic_pad.H Wlt/wavelet_redatum_acoustic_large_box.H Vel/mask_elastic_scat_dat.H #ela_bornhx_inv_mask_smooth
	Math file1=ElaBornHxMaskLarge20m/ela_born_ext_hx_mask_large_20m.invmod.H file2=Vel/mask_elastic_scat_dat_large.H exp="file1*file2" | Window3d min1=1.2 squeeze=0 | Pad beg1=200 > temp_pert_elahx_box_large_smooth20m.H
	${SCRIPTDIR}/batch_task_executor_ext_born_fwd.py pbs_template=${PBS_TMPL} os=101 nshots=${nshots_large_box} nshotjob=2 ds=10 model=../temp_pert_elahx_box_large_smooth20m.H vel=../Vel/true_smooth_vp_aco_smooth_box_large.acoustic_pad.H hzmax=0 hxmax=80 htmax=0 par=../Par/ela.box.inv.10km.fwd.p queues=sep,default queues_cap=30,30 path_out=wrk prefix=e20mbornlabo total_jobs_cap=24,300
	#Scaling of the source wavelet (need to understand additional scaling factor)
	Add e20mbornlabo-final.H scale=0.386014525334981 | Add scale=1.9159165294586593 > $@
	Rm temp_pert_elahx_box_large_smooth20m.H e20mbornlabo-final.H

#Mask no dipole strong mask non-extended
${D}/ela_scat_data_box_back_large_strong_nohx.H: Vel/true_smooth_vp_aco_smooth_box_large.acoustic_pad.H Wlt/wavelet_redatum_acoustic_large_box.H Vel/mask_elastic_scat_dat_large_strong.H #ela_bornhx_inv_mask_smooth
	Window3d < Vel/mask_elastic_scat_dat_large_strong.H n4=1 f4=80 > tmp_mask.H
	Math file1=ElaBornMaskLarge/ela_born_mask_large.invmod.H file2=tmp_mask.H exp="file1*file2" | Window3d min1=1.2 squeeze=0 | Pad beg1=200 > temp_pert_elahx_box_large_smooth_strong_nohx.H
	${SCRIPTDIR}/batch_task_executor_ext_born_fwd.py pbs_template=${PBS_TMPL} os=101 nshots=${nshots_large_box} nshotjob=2 ds=10 model=../temp_pert_elahx_box_large_smooth_strong_nohx.H vel=../Vel/true_smooth_vp_aco_smooth_box_large.acoustic_pad.H hzmax=0 hxmax=0 htmax=0 par=../Par/ela.box.inv.10km.fwd.p queues=sep,default queues_cap=30,30 path_out=wrk prefix=elabnohxsto total_jobs_cap=24,300
	#Scaling of the source wavelet (need to understand additional scaling factor)
	Add elabnohxsto-final.H scale=0.386014525334981 | Add scale=1.9159165294586593 > $@
	Rm temp_pert_elahx_box_large_smooth_strong_nohx.H elabnohxsto-final.H tmp_mask.H
	

#No mask no dipole
${D}/ela_scat_data_box_back_large_nomask.H: Vel/true_smooth_vp_aco_smooth_box_large.acoustic_pad.H Wlt/wavelet_redatum_acoustic_large_box.H Vel/mask_elastic_scat_dat.H #ela_bornhx_inv_mask_smooth
	Math file1=ElaBornHxNoMaskLarge/ela_born_ext_hx_nomask_large.invmod.H file2=Vel/mask_elastic_scat_dat_large.H exp="file1*file2" | Window3d min1=1.2 squeeze=0 | Pad beg1=200 > temp_pert_elahx_box_large_smooth_nomask.H
	${SCRIPTDIR}/batch_task_executor_ext_born_fwd.py pbs_template=${PBS_TMPL} os=101 nshots=${nshots_large_box} nshotjob=2 ds=10 model=../temp_pert_elahx_box_large_smooth_nomask.H vel=../Vel/true_smooth_vp_aco_smooth_box_large.acoustic_pad.H hzmax=0 hxmax=80 htmax=0 par=../Par/ela.box.inv.10km.fwd.p queues=sep,default queues_cap=30,30 path_out=wrk prefix=elabornnmask total_jobs_cap=24,300
	#Scaling of the source wavelet (need to understand additional scaling factor)
	Add elabornnmask-final.H scale=0.386014525334981 | Add scale=1.9159165294586593 > $@
	Rm temp_pert_elahx_box_large_smooth_nomask.H elabornnmask-final.H


compare_delta_data_ela_box_smooth_large_strong_shot%: #${D}/pressure-elastic_data_box_large.H ${D}/pressure-elastic_data_back_box_large.H ${D}/ela_scat_data_box_back_large_strong.H
	Window3d < ${D}/pressure-elastic_data_box_large.H f2=200 n2=600 n3=1 f3=$* > tmp_true.H
	Window3d < ${D}/pressure-elastic_data_back_box_large.H f2=200 n2=600 n3=1 f3=$* > tmp_back.H
	Window3d < ${D}/ela_scat_data_box_back_large_strong.H f2=200 n2=600 n3=1 f3=$*  > tmp_reco.H
	Add tmp_true.H tmp_back.H scale=1,-1   > diff.H
	Add diff.H tmp_reco.H scale=1,-1 > diff_diff.H
	Cat3d diff.H tmp_reco.H diff_diff.H axis=3 | Grey titles="d_true-d_background:Born_hx:difference" pclip=99.5 gainpanel=a | Tube pixmaps=1 &
	Rm diff.H diff_diff.H tmp_true.H tmp_back.H tmp_reco.H
	
compare_delta_data_ela_box_smooth_large_strong20m_shot%: #${D}/pressure-elastic_data_box_large.H ${D}/pressure-elastic_data_back_box_large.H ${D}/ela_scat_data_box_back_large_strong.H
	Window3d < ${D}/pressure-elastic_data_box_large.H f2=200 n2=600 n3=1 f3=$* > tmp_true.H
	Window3d < ${D}/pressure-elastic_data_back_box_large.H f2=200 n2=600 n3=1 f3=$* > tmp_back.H
	Window3d < ${D}/ela_scat_data_box_back_large_strong20m.H f2=200 n2=600 n3=1 f3=$*  > tmp_reco.H
	Add tmp_true.H tmp_back.H scale=1,-1   > diff.H
	Add diff.H tmp_reco.H scale=1,-1 > diff_diff.H
	Cat3d diff.H tmp_reco.H diff_diff.H axis=3 | Grey titles="d_true-d_background:Born_hx:difference" pclip=99.5 gainpanel=a | Tube pixmaps=1 &
	Rm diff.H diff_diff.H tmp_true.H tmp_back.H tmp_reco.H
	
compare_delta_data_ela_box_smooth_large_nohx_strong_shot%: #${D}/pressure-elastic_data_box_large.H ${D}/pressure-elastic_data_back_box_large.H ${D}/ela_scat_data_box_back_large_strong.H
	Window3d < ${D}/pressure-elastic_data_box_large.H f2=200 n2=600 n3=1 f3=$* > tmp_true.H
	Window3d < ${D}/pressure-elastic_data_back_box_large.H f2=200 n2=600 n3=1 f3=$* > tmp_back.H
	Window3d < ${D}/ela_scat_data_box_back_large_strong_nohx.H f2=200 n2=600 n3=1 f3=$*  > tmp_reco.H
	Add tmp_true.H tmp_back.H scale=1,-1   > diff.H
	Add diff.H tmp_reco.H scale=1,-1 > diff_diff.H
	Cat3d diff.H tmp_reco.H diff_diff.H axis=3 | Grey titles="d_true-d_background:Born_hx:difference" pclip=99.5 gainpanel=a | Tube pixmaps=1 &
	Rm diff.H diff_diff.H tmp_true.H tmp_back.H tmp_reco.H
	
compare_delta_data_ela_box_smooth_large_shot%: #${D}/pressure-elastic_data_box_large.H ${D}/pressure-elastic_data_back_box_large.H ${D}/ela_scat_data_box_back_large.H
	Window3d < ${D}/pressure-elastic_data_box_large.H f2=200 n2=600 n3=1 f3=$* > tmp_true.H
	Window3d < ${D}/pressure-elastic_data_back_box_large.H f2=200 n2=600 n3=1 f3=$* > tmp_back.H
	Window3d < ${D}/ela_scat_data_box_back_large.H f2=200 n2=600 n3=1 f3=$* > tmp_reco.H
	Add tmp_true.H tmp_back.H scale=1,-1  > diff.H
	Add diff.H tmp_reco.H scale=1,-1 > diff_diff.H
	Cat3d diff.H tmp_reco.H diff_diff.H axis=3 | Grey titles="d_true-d_background:Born_hx:difference" pclip=99.5 gainpanel=a | Tube pixmaps=1 &
	Rm diff.H diff_diff.H tmp_true.H tmp_back.H tmp_reco.H
	
	
compare_delta_data_ela_box_smooth_large_nomask_shot%: #${D}/pressure-elastic_data_box_large.H ${D}/pressure-elastic_data_back_box_large.H ${D}/ela_scat_data_box_back_large_nomask.H
	Window3d < ${D}/pressure-elastic_data_box_large.H f2=200 n2=600 n3=1 f3=$* > tmp_true.H
	Window3d < ${D}/pressure-elastic_data_back_box_large.H f2=200 n2=600 n3=1 f3=$* > tmp_back.H
	Window3d < ${D}/ela_scat_data_box_back_large_nomask.H f2=200 n2=600 n3=1 f3=$* > tmp_reco.H
	Add tmp_true.H tmp_back.H scale=1,-1  > diff.H
	Add diff.H tmp_reco.H scale=1,-1 > diff_diff.H
	Cat3d diff.H tmp_reco.H diff_diff.H axis=3 | Grey titles="d_true-d_background:Born_hx:difference" pclip=99.5 gainpanel=a | Tube pixmaps=1 &
	Rm diff.H diff_diff.H tmp_true.H tmp_back.H tmp_reco.H
	
	
${D}/diff_large.H: ${D}/pressure-elastic_data_box_large.H ${D}/pressure-elastic_data_back_box_large.H ${D}/ela_scat_data_box_back_large.H
	Window3d < ${D}/pressure-elastic_data_box_large.H f2=200 n2=600 f3=20 n3=60 > tmp_true.H
	Window3d < ${D}/pressure-elastic_data_back_box_large.H f2=200 n2=600 f3=20 n3=60 > tmp_back.H
	Window3d < ${D}/ela_scat_data_box_back_large.H f2=200 n2=600 f3=20 n3=60 > tmp_reco.H
	Add tmp_true.H tmp_back.H scale=1,-1  > diff.H
	Add diff.H tmp_reco.H scale=1,-1 > $@
	Rm diff.H tmp_true.H tmp_back.H tmp_reco.H
	
${D}/mapped_res_mod.H: ${D}/diff_large.H Vel/true_smooth_vp_aco_smooth_box_large.acoustic_pad.H Wlt/wavelet_redatum_acoustic_large_box.H
	${SCRIPTDIR}/batch_task_executor_ext_born_adj.py pbs_template=${PBS_TMPL} os=101 nshots=60 nshotjob=1 ds=10 data=../$< vel=../Vel/true_smooth_vp_aco_smooth_box_large_cut.acoustic_pad.H hzmax=0 hxmax=80 htmax=0 par=../${P}/ela.box.inv.8km.fwd.p queues=sep,default queues_cap=30,30 path_out=wrk prefix=mapping total_jobs_cap=24,400
	mv mapping-final.H $@
	

##########################################################################################
#Elastic FWI on true localized data and reconstructed one
##########################################################################################
#Removing first and last 200 meters of shots and receivers
#Reconstructed data
${D}/reconstructed_data_smooth_large.H: ${D}/pressure-elastic_data_back_box_large.H ${D}/ela_scat_data_box_back_large.H
	Add ${D}/pressure-elastic_data_back_box_large.H ${D}/ela_scat_data_box_back_large.H | Window3d f2=200 n2=600 f3=20 n3=60  > $@
#True data
${D}/true_data_smooth_large_box.H: ${D}/pressure-elastic_data_box_large.H
	Window3d f2=200 n2=600 f3=20 n3=60 < $< > $@
	
#Reconstructed data using a strong mask
${D}/reconstructed_data_smooth_large_strong.H: ${D}/pressure-elastic_data_back_box_large.H ${D}/ela_scat_data_box_back_large_strong.H
	Add ${D}/pressure-elastic_data_back_box_large.H ${D}/ela_scat_data_box_back_large_strong.H | Window3d f2=200 n2=600 f3=20 n3=60  > $@

compare_shot%:
	Add ${D}/true_data_smooth_large_box.H ${D}/reconstructed_data_smooth_large.H scale=1,-1 > diff.H
	Cat3d ${D}/true_data_smooth_large_box.H ${D}/reconstructed_data_smooth_large.H diff.H axis=4 | Window3d n3=1 f3=$* | Grey | Tube 
	Rm diff.H

compare_strong_shot%:
	Add ${D}/true_data_smooth_large_box.H ${D}/reconstructed_data_smooth_large_strong.H scale=1,-1 > diff.H
	Cat3d ${D}/true_data_smooth_large_box.H ${D}/reconstructed_data_smooth_large_strong.H diff.H axis=4 | Window3d n3=1 f3=$* | Grey pclip=99.5 gainpanel=e | Tube 
	Rm diff.H
	
#Creating starting model (using windowed model)
Vel/true_smooth_ela_smooth_large_fwi_init.H: Vel/true_smooth_ela_smooth_large.H
	Window3d < $< min1=1200 f2=200 n2=600 squeeze=0 >$@
	
Vel/true_smooth_ela_smooth_large_fwi_init.inv_elastic_pad.H: Vel/true_smooth_ela_smooth_large_fwi_init.H
	Pad beg1=200 end1=200 beg2=200 end2=200 <$< extend=1 >$@

#Inversion mask
Vel/inv_elastic_mask_large.H: Vel/true_smooth_ela_smooth_large_fwi_init.inv_elastic_pad.H
	Math file1=$< exp="file1*0.0+1.0" | Window3d min1=1400 squeeze=n | Pad beg1=220 | Smooth rect1=4 > $@

#Acquisition geometry
#Source positions
${P}/sou_unif_elastic_large_fwi.p: Vel/true_smooth_ela_smooth_large_fwi_init.H link-Geo_uniform.x
	Window3d < $< n4=1 squeeze=0 | ${B}/Geo_uniform.x depth=1200. dx=100. file=$@ >/dev/null
#Receiver positions
${P}/rec_unif_elastic_large_fwi.p: Vel/true_smooth_ela_smooth_large_fwi_init.H link-Geo_uniform.x
	Window3d < $< n4=1 squeeze=0 |  ${B}/Geo_uniform.x depth=1200. dx=10. file=$@ >/dev/null	

#Elastic FWI using NLCG using true data
vpvsrho_true_data_elastic_fwi_large: solver_prog ${D}/true_data_smooth_large_box.H Vel/true_smooth_ela_smooth_large_fwi_init.inv_elastic_pad.H link-Bornfast_elastic_adj.x link-Bornfast_elastic_fw.x link-Propagator_elastic_fw.x ${P}/sou_unif_elastic_large_fwi.p ${P}/rec_unif_elastic_large_fwi.p Wlt/wavelet_redatum_elastic_large_box.H Vel/inv_elastic_mask_large.H
	${B}/nl_solver.py fwd_nl_cmd_file=${P}/vpvsrho_box_large.nl.fwd.p fwd_cmd_file=${P}/vpvsrho_box_large.lin.fwd.p  adj_cmd_file=${P}/vpvsrho_box_large.lin.adj.p data=${D}/true_data_smooth_large_box.H init_model=Vel/true_smooth_ela_smooth_large_fwi_init.inv_elastic_pad.H inv_model=vpvsrho.box.large.inv.true.nlcg.invmod.H suffix=vpvsrho.box.large.inv.true.nlcg iteration_movies=obj,model,gradient,residual niter=200 wrk_dir=ElaFWIVpVsRhoBoxLargeTrueNLCG restart=y 

#Elastic FWI using NLCG using reconstructed data
vpvsrho_reco_data_elastic_fwi_large: solver_prog ${D}/reconstructed_data_smooth_large.H Vel/true_smooth_ela_smooth_large_fwi_init.inv_elastic_pad.H link-Bornfast_elastic_adj.x link-Bornfast_elastic_fw.x link-Propagator_elastic_fw.x ${P}/sou_unif_elastic_large_fwi.p ${P}/rec_unif_elastic_large_fwi.p Wlt/wavelet_redatum_elastic_large_box.H Vel/inv_elastic_mask_large.H
	${B}/nl_solver.py fwd_nl_cmd_file=${P}/vpvsrho_box_large.nl.fwd.p fwd_cmd_file=${P}/vpvsrho_box_large.lin.fwd.p  adj_cmd_file=${P}/vpvsrho_box_large.lin.adj.p data=${D}/reconstructed_data_smooth_large.H init_model=Vel/true_smooth_ela_smooth_large_fwi_init.inv_elastic_pad.H inv_model=vpvsrho.box.large.inv.reco.nlcg.invmod.H suffix=vpvsrho.box.large.inv.reco.nlcg iteration_movies=obj,model,gradient,residual niter=200 wrk_dir=ElaFWIVpVsRhoBoxLargeRecoNLCG restart=y 

#####################
#Multi-scale approach
#####################
#Bandpassing the wavelet
Wlt/wavelet_redatum_elastic_large_box_bp2-%.H: Wlt/wavelet_redatum_elastic_large_box.H
	Bandpass < $< fhi=$* phase=1 | Bandpass fhi=$* phase=1 | Bandpass fhi=$* phase=1 | Add scale=1e9 > $@
#Bandpassing the reconstructed data data
${D}/reconstructed_data_smooth_large_bp2-%.H: ${D}/reconstructed_data_smooth_large.H
	Bandpass < $< fhi=$* phase=1 | Bandpass fhi=$* phase=1 | Bandpass fhi=$* phase=1 | Add scale=1e9 > $@
#Bandpassing the reconstructed data data using strong mask
${D}/reconstructed_data_smooth_large_stong_bp2-%.H: ${D}/reconstructed_data_smooth_large_strong.H
	Bandpass < $< fhi=$* phase=1 | Bandpass fhi=$* phase=1 | Bandpass fhi=$* phase=1 | Add scale=1e9 > $@
#Bandpassing the reconstructed data data
${D}/true_data_smooth_large_box_bp2-%.H: ${D}/true_data_smooth_large_box.H
	Bandpass < $< fhi=$* phase=1 | Bandpass fhi=$* phase=1 | Bandpass fhi=$* phase=1 | Add scale=1e9 > $@

#First band 2-10 Hz
#Elastic FWI using NLCG using true data
vpvsrho_true_data_elastic_fwi_large_bp2-10: solver_prog ${D}/true_data_smooth_large_box_bp2-10.H Vel/true_smooth_ela_smooth_large_fwi_init.inv_elastic_pad.H link-Bornfast_elastic_adj.x link-Bornfast_elastic_fw.x link-Propagator_elastic_fw.x ${P}/sou_unif_elastic_large_fwi.p ${P}/rec_unif_elastic_large_fwi.p Wlt/wavelet_redatum_elastic_large_box_bp2-10.H Vel/inv_elastic_mask_large.H
	sed < ${P}/vpvsrho_box_large.nl.fwd.p 's/wavelet_redatum_elastic_large_box/wavelet_redatum_elastic_large_box_bp2-10/' > ${P}/vpvsrho_box_large_bp2-10.nl.fwd.p
	sed < ${P}/vpvsrho_box_large.lin.fwd.p 's/wavelet_redatum_elastic_large_box/wavelet_redatum_elastic_large_box_bp2-10/' > ${P}/vpvsrho_box_large_bp2-10.lin.fwd.p
	sed < ${P}/vpvsrho_box_large.lin.adj.p 's/wavelet_redatum_elastic_large_box/wavelet_redatum_elastic_large_box_bp2-10/' > ${P}/vpvsrho_box_large_bp2-10.lin.adj.p
	${B}/nl_solver.py fwd_nl_cmd_file=${P}/vpvsrho_box_large_bp2-10.nl.fwd.p fwd_cmd_file=${P}/vpvsrho_box_large_bp2-10.lin.fwd.p adj_cmd_file=${P}/vpvsrho_box_large_bp2-10.lin.adj.p data=${D}/true_data_smooth_large_box_bp2-10.H init_model=Vel/true_smooth_ela_smooth_large_fwi_init.inv_elastic_pad.H inv_model=vpvsrho.box.large.inv.true.10hz.nlcg.invmod.H suffix=vpvsrho.box.large.inv.true.10hz.nlcg iteration_movies=obj,model,gradient,residual niter=100 wrk_dir=ElaFWIVpVsRhoBoxLargeTrueNLCG10Hz

#Second band 2-20 Hz
#Elastic FWI using NLCG using true data
vpvsrho_true_data_elastic_fwi_large_bp2-20: vpvsrho_true_data_elastic_fwi_large_bp2-10 solver_prog ${D}/true_data_smooth_large_box_bp2-20.H Vel/true_smooth_ela_smooth_large_fwi_init.inv_elastic_pad.H link-Bornfast_elastic_adj.x link-Bornfast_elastic_fw.x link-Propagator_elastic_fw.x ${P}/sou_unif_elastic_large_fwi.p ${P}/rec_unif_elastic_large_fwi.p Wlt/wavelet_redatum_elastic_large_box_bp2-20.H Vel/inv_elastic_mask_large.H #vpvsrho_true_data_elastic_fwi_large_bp2-10
	sed < ${P}/vpvsrho_box_large.nl.fwd.p 's/wavelet_redatum_elastic_large_box/wavelet_redatum_elastic_large_box_bp2-20/' > ${P}/vpvsrho_box_large_bp2-20.nl.fwd.p
	sed < ${P}/vpvsrho_box_large.lin.fwd.p 's/wavelet_redatum_elastic_large_box/wavelet_redatum_elastic_large_box_bp2-20/' > ${P}/vpvsrho_box_large_bp2-20.lin.fwd.p
	sed < ${P}/vpvsrho_box_large.lin.adj.p 's/wavelet_redatum_elastic_large_box/wavelet_redatum_elastic_large_box_bp2-20/' > ${P}/vpvsrho_box_large_bp2-20.lin.adj.p
	${B}/nl_solver.py fwd_nl_cmd_file=${P}/vpvsrho_box_large_bp2-20.nl.fwd.p fwd_cmd_file=${P}/vpvsrho_box_large_bp2-20.lin.fwd.p adj_cmd_file=${P}/vpvsrho_box_large_bp2-20.lin.adj.p data=${D}/true_data_smooth_large_box_bp2-20.H init_model=ElaFWIVpVsRhoBoxLargeTrueNLCG10Hz/vpvsrho.box.large.inv.true.10hz.nlcg.invmod.H inv_model=vpvsrho.box.large.inv.true.20hz.nlcg.invmod.H suffix=vpvsrho.box.large.inv.true.20hz.nlcg iteration_movies=obj,model,gradient,residual niter=100 wrk_dir=ElaFWIVpVsRhoBoxLargeTrueNLCG20Hz

#Last band 2-30 Hz
#Elastic FWI using NLCG using true data
vpvsrho_true_data_elastic_fwi_large_all: vpvsrho_true_data_elastic_fwi_large_bp2-20 solver_prog ${D}/true_data_smooth_large_box.H Vel/true_smooth_ela_smooth_large_fwi_init.inv_elastic_pad.H link-Bornfast_elastic_adj.x link-Bornfast_elastic_fw.x link-Propagator_elastic_fw.x ${P}/sou_unif_elastic_large_fwi.p ${P}/rec_unif_elastic_large_fwi.p Wlt/wavelet_redatum_elastic_large_box.H Vel/inv_elastic_mask_large.H #vpvsrho_true_data_elastic_fwi_large_bp2-10
	${B}/nl_solver.py fwd_nl_cmd_file=${P}/vpvsrho_box_large.nl.fwd.p fwd_cmd_file=${P}/vpvsrho_box_large.lin.fwd.p adj_cmd_file=${P}/vpvsrho_box_large.lin.adj.p data=${D}/true_data_smooth_large_box.H init_model=ElaFWIVpVsRhoBoxLargeTrueNLCG20Hz/vpvsrho.box.large.inv.true.20hz.nlcg.invmod.H inv_model=vpvsrho.box.large.inv.true.all.nlcg.invmod.H suffix=vpvsrho.box.large.inv.true.all.nlcg iteration_movies=obj,model,gradient,residual niter=100 wrk_dir=ElaFWIVpVsRhoBoxLargeTrueNLCG30Hz

#First band 2-10 Hz
#Elastic FWI using NLCG using reconstructed data
vpvsrho_reco_data_elastic_fwi_large_bp2-10: solver_prog ${D}/reconstructed_data_smooth_large_bp2-10.H Vel/true_smooth_ela_smooth_large_fwi_init.inv_elastic_pad.H link-Bornfast_elastic_adj.x link-Bornfast_elastic_fw.x link-Propagator_elastic_fw.x ${P}/sou_unif_elastic_large_fwi.p ${P}/rec_unif_elastic_large_fwi.p Wlt/wavelet_redatum_elastic_large_box_bp2-10.H Vel/inv_elastic_mask_large.H
	sed < ${P}/vpvsrho_box_large.nl.fwd.p 's/wavelet_redatum_elastic_large_box/wavelet_redatum_elastic_large_box_bp2-10/' > ${P}/vpvsrho_box_large_bp2-10.nl.fwd.p
	sed < ${P}/vpvsrho_box_large.lin.fwd.p 's/wavelet_redatum_elastic_large_box/wavelet_redatum_elastic_large_box_bp2-10/' > ${P}/vpvsrho_box_large_bp2-10.lin.fwd.p
	sed < ${P}/vpvsrho_box_large.lin.adj.p 's/wavelet_redatum_elastic_large_box/wavelet_redatum_elastic_large_box_bp2-10/' > ${P}/vpvsrho_box_large_bp2-10.lin.adj.p
	${B}/nl_solver.py fwd_nl_cmd_file=${P}/vpvsrho_box_large_bp2-10.nl.fwd.p fwd_cmd_file=${P}/vpvsrho_box_large_bp2-10.lin.fwd.p adj_cmd_file=${P}/vpvsrho_box_large_bp2-10.lin.adj.p data=${D}/reconstructed_data_smooth_large_bp2-10.H init_model=Vel/true_smooth_ela_smooth_large_fwi_init.inv_elastic_pad.H inv_model=vpvsrho.box.large.inv.reco.10hz.nlcg.invmod.H suffix=vpvsrho.box.large.inv.reco.10hz.nlcg iteration_movies=obj,model,gradient,residual niter=100 wrk_dir=ElaFWIVpVsRhoBoxLargeRecoNLCG10Hz 

#Second band 2-20 Hz
#Elastic FWI using NLCG using reconstructed data
vpvsrho_reco_data_elastic_fwi_large_bp2-20: vpvsrho_reco_data_elastic_fwi_large_bp2-10 solver_prog ${D}/reconstructed_data_smooth_large_bp2-20.H Vel/true_smooth_ela_smooth_large_fwi_init.inv_elastic_pad.H link-Bornfast_elastic_adj.x link-Bornfast_elastic_fw.x link-Propagator_elastic_fw.x ${P}/sou_unif_elastic_large_fwi.p ${P}/rec_unif_elastic_large_fwi.p Wlt/wavelet_redatum_elastic_large_box_bp2-20.H Vel/inv_elastic_mask_large.H #vpvsrho_reco_data_elastic_fwi_large_bp2-20
	sed < ${P}/vpvsrho_box_large.nl.fwd.p 's/wavelet_redatum_elastic_large_box/wavelet_redatum_elastic_large_box_bp2-20/' > ${P}/vpvsrho_box_large_bp2-20.nl.fwd.p
	sed < ${P}/vpvsrho_box_large.lin.fwd.p 's/wavelet_redatum_elastic_large_box/wavelet_redatum_elastic_large_box_bp2-20/' > ${P}/vpvsrho_box_large_bp2-20.lin.fwd.p
	sed < ${P}/vpvsrho_box_large.lin.adj.p 's/wavelet_redatum_elastic_large_box/wavelet_redatum_elastic_large_box_bp2-20/' > ${P}/vpvsrho_box_large_bp2-20.lin.adj.p
	${B}/nl_solver.py fwd_nl_cmd_file=${P}/vpvsrho_box_large_bp2-20.nl.fwd.p fwd_cmd_file=${P}/vpvsrho_box_large_bp2-20.lin.fwd.p adj_cmd_file=${P}/vpvsrho_box_large_bp2-20.lin.adj.p data=${D}/reconstructed_data_smooth_large_bp2-20.H init_model=ElaFWIVpVsRhoBoxLargeRecoNLCG10Hz/vpvsrho.box.large.inv.reco.10hz.nlcg.invmod.H inv_model=vpvsrho.box.large.inv.reco.20hz.nlcg.invmod.H suffix=vpvsrho.box.large.inv.reco.20hz.nlcg iteration_movies=obj,model,gradient,residual niter=100 wrk_dir=ElaFWIVpVsRhoBoxLargeRecoNLCG20Hz 
	
#Last band 2-30 Hz
#Elastic FWI using NLCG using reconstructed data
vpvsrho_reco_data_elastic_fwi_large_all: vpvsrho_reco_data_elastic_fwi_large_bp2-20 solver_prog ${D}/reconstructed_data_smooth_large.H Vel/true_smooth_ela_smooth_large_fwi_init.inv_elastic_pad.H link-Bornfast_elastic_adj.x link-Bornfast_elastic_fw.x link-Propagator_elastic_fw.x ${P}/sou_unif_elastic_large_fwi.p ${P}/rec_unif_elastic_large_fwi.p Wlt/wavelet_redatum_elastic_large_box.H Vel/inv_elastic_mask_large.H #vpvsrho_reco_data_elastic_fwi_large_bp2-20
	${B}/nl_solver.py fwd_nl_cmd_file=${P}/vpvsrho_box_large.nl.fwd.p fwd_cmd_file=${P}/vpvsrho_box_large.lin.fwd.p adj_cmd_file=${P}/vpvsrho_box_large.lin.adj.p data=${D}/reconstructed_data_smooth_large.H init_model=ElaFWIVpVsRhoBoxLargeRecoNLCG20Hz/vpvsrho.box.large.inv.reco.20hz.nlcg.invmod.H inv_model=vpvsrho.box.large.inv.reco.all.nlcg.invmod.H suffix=vpvsrho.box.large.inv.reco.all.nlcg iteration_movies=obj,model,gradient,residual niter=100 wrk_dir=ElaFWIVpVsRhoBoxLargeRecoNLCG30Hz 
	
#First band 2-10 Hz
#Elastic FWI using NLCG using reconstructed data using strong mask
vpvsrho_reco_data_elastic_fwi_large_strong_bp2-10: solver_prog ${D}/reconstructed_data_smooth_large_stong_bp2-10.H Vel/true_smooth_ela_smooth_large_fwi_init.inv_elastic_pad.H link-Bornfast_elastic_adj.x link-Bornfast_elastic_fw.x link-Propagator_elastic_fw.x ${P}/sou_unif_elastic_large_fwi.p ${P}/rec_unif_elastic_large_fwi.p Wlt/wavelet_redatum_elastic_large_box_bp2-10.H Vel/inv_elastic_mask_large.H
	sed < ${P}/vpvsrho_box_large.nl.fwd.p 's/wavelet_redatum_elastic_large_box/wavelet_redatum_elastic_large_box_bp2-10/' > ${P}/vpvsrho_box_large_bp2-10.nl.fwd.p
	sed < ${P}/vpvsrho_box_large.lin.fwd.p 's/wavelet_redatum_elastic_large_box/wavelet_redatum_elastic_large_box_bp2-10/' > ${P}/vpvsrho_box_large_bp2-10.lin.fwd.p
	sed < ${P}/vpvsrho_box_large.lin.adj.p 's/wavelet_redatum_elastic_large_box/wavelet_redatum_elastic_large_box_bp2-10/' > ${P}/vpvsrho_box_large_bp2-10.lin.adj.p
	${B}/nl_solver.py fwd_nl_cmd_file=${P}/vpvsrho_box_large_bp2-10.nl.fwd.p fwd_cmd_file=${P}/vpvsrho_box_large_bp2-10.lin.fwd.p adj_cmd_file=${P}/vpvsrho_box_large_bp2-10.lin.adj.p data=${D}/reconstructed_data_smooth_large_stong_bp2-10.H init_model=Vel/true_smooth_ela_smooth_large_fwi_init.inv_elastic_pad.H inv_model=vpvsrho.box.large.strong.inv.reco.10hz.nlcg.invmod.H suffix=vpvsrho.box.large.strong.inv.reco.10hz.nlcg iteration_movies=obj,model,gradient,residual niter=100 wrk_dir=ElaFWIVpVsRhoBoxLargeStrongRecoNLCG10Hz restart=y 

#Second band 2-20 Hz
#Elastic FWI using NLCG using reconstructed data using strong mask
vpvsrho_reco_data_elastic_fwi_large_strong_bp2-20: solver_prog ${D}/reconstructed_data_smooth_large_stong_bp2-20.H Vel/true_smooth_ela_smooth_large_fwi_init.inv_elastic_pad.H link-Bornfast_elastic_adj.x link-Bornfast_elastic_fw.x link-Propagator_elastic_fw.x ${P}/sou_unif_elastic_large_fwi.p ${P}/rec_unif_elastic_large_fwi.p Wlt/wavelet_redatum_elastic_large_box_bp2-20.H Vel/inv_elastic_mask_large.H #vpvsrho_reco_data_elastic_fwi_large_strong_bp2-10
	sed < ${P}/vpvsrho_box_large.nl.fwd.p 's/wavelet_redatum_elastic_large_box/wavelet_redatum_elastic_large_box_bp2-20/' > ${P}/vpvsrho_box_large_bp2-20.nl.fwd.p
	sed < ${P}/vpvsrho_box_large.lin.fwd.p 's/wavelet_redatum_elastic_large_box/wavelet_redatum_elastic_large_box_bp2-20/' > ${P}/vpvsrho_box_large_bp2-20.lin.fwd.p
	sed < ${P}/vpvsrho_box_large.lin.adj.p 's/wavelet_redatum_elastic_large_box/wavelet_redatum_elastic_large_box_bp2-20/' > ${P}/vpvsrho_box_large_bp2-20.lin.adj.p
	${B}/nl_solver.py fwd_nl_cmd_file=${P}/vpvsrho_box_large_bp2-20.nl.fwd.p fwd_cmd_file=${P}/vpvsrho_box_large_bp2-20.lin.fwd.p adj_cmd_file=${P}/vpvsrho_box_large_bp2-20.lin.adj.p data=${D}/reconstructed_data_smooth_large_stong_bp2-20.H init_model=ElaFWIVpVsRhoBoxLargeStrongRecoNLCG10Hz/vpvsrho.box.large.strong.inv.reco.10hz.nlcg.invmod.H inv_model=vpvsrho.box.large.strong.inv.reco.20hz.nlcg.invmod.H suffix=vpvsrho.box.large.strong.inv.reco.20hz.nlcg iteration_movies=obj,model,gradient,residual niter=100 wrk_dir=ElaFWIVpVsRhoBoxLargeStrongRecoNLCG20Hz debug=y restart=y
	
#Last band 2-30 Hz
#Elastic FWI using NLCG using reconstructed data
vpvsrho_reco_data_elastic_fwi_large_strong_strong_all: solver_prog ${D}/reconstructed_data_smooth_large_strong.H Vel/true_smooth_ela_smooth_large_fwi_init.inv_elastic_pad.H link-Bornfast_elastic_adj.x link-Bornfast_elastic_fw.x link-Propagator_elastic_fw.x ${P}/sou_unif_elastic_large_fwi.p ${P}/rec_unif_elastic_large_fwi.p Wlt/wavelet_redatum_elastic_large_box.H Vel/inv_elastic_mask_large.H #vpvsrho_reco_data_elastic_fwi_large_strong_bp2-20
	${B}/nl_solver.py fwd_nl_cmd_file=${P}/vpvsrho_box_large.nl.fwd.p fwd_cmd_file=${P}/vpvsrho_box_large.lin.fwd.p adj_cmd_file=${P}/vpvsrho_box_large.lin.adj.p data=${D}/reconstructed_data_smooth_large_strong.H init_model=ElaFWIVpVsRhoBoxLargeStrongRecoNLCG20Hz/vpvsrho.box.large.strong.inv.reco.20hz.nlcg.invmod.H  inv_model=vpvsrho.box.large.strong.inv.reco.all.nlcg.invmod.H suffix=vpvsrho.box.large.strong.inv.reco.all.nlcg iteration_movies=obj,model,gradient,residual niter=100 wrk_dir=ElaFWIVpVsRhoBoxLargeStrongRecoNLCG30Hz restart=y

##########################################################################################
#Compare extended perturbations
##########################################################################################
compare_xz_surf_sunk:
	Window3d < ElaBornHxMaskLargeCont/ela_born_ext_hx_mask_large_cont.invmod.H min1=1.2 max1=2.5 min2=2 max2=8 j4=2 | Scale > top.H
	Window3d < ElaBornHxNoMaskBoxLarge8km/ela_born_ext_hx_nomask_box_large_8km.invmod.H min1=1.2 max1=2.5 min2=2 max2=8 j4=2 | Scale > bottom.H
	Add top.H bottom.H scale=1,-1 > diff.H
	Window3d < top.H n3=1 f3=40 > top_zero.H
	Window3d < bottom.H n3=1 f3=40 > bottom_zero.H
	Window3d < diff.H n3=1 f3=40 > diff_zero.H
	Cat3d top.H bottom.H diff.H axis=2 | Grey gainpanel=a pclip=100 title="surf-sunk-diff" | Tube 
	Cat3d top_zero.H bottom_zero.H diff_zero.H axis=3 | Grey gainpanel=a pclip=100 titles="surf:sunk:diff" grid=y | Tube 
	Cat3d top_zero.H bottom_zero.H diff_zero.H axis=3 | Window3d min2=5.5 n2=1 | Graph curvelabel="surf:sunk:diff" legend=y | Tube 
	Rm top.H bottom.H diff.H top_zero.H bottom_zero.H diff_zero.H
	
compare_zh_surf_sunk:
	Window3d < ElaBornHxMaskLargeCont/ela_born_ext_hx_mask_large_cont.invmod.H min1=1.2 max1=2.5 min2=2 max2=8 | Transp plane=23 | Scale > top.H
	Window3d < ElaBornHxNoMaskBoxLarge8km/ela_born_ext_hx_nomask_box_large_8km.invmod.H min1=1.2 max1=2.5 min2=2 max2=8 | Transp plane=23 | Scale > bottom.H
	Add top.H bottom.H scale=1,-1 > diff.H
	Window3d < top.H n3=1 min3=5.5 > top_zero.H
	Window3d < bottom.H n3=1 min3=5.5 > bottom_zero.H
	Window3d < diff.H n3=1 min3=5.5 > diff_zero.H
	Cat3d top.H bottom.H diff.H axis=2 | Window3d j4=2 | Grey gainpanel=a pclip=100 title="surf-sunk-diff" grid=y | Tube 
	Cat3d top_zero.H bottom_zero.H diff_zero.H axis=3 | Grey gainpanel=a pclip=100 titles="surf:sunk:diff" grid=y | Tube 
	Rm top.H bottom.H diff.H top_zero.H bottom_zero.H diff_zero.H
	
	








