!Program to run dot-product on adjoint scattering condition 
program Dot_elastic_imaging

	use sep
	use full_elastic_imaging_mod
	
	implicit none
	integer										:: nz,nx,ny
	real										:: dz,dx,dy
	logical										:: twoD=.true.
	real,dimension(:,:,:),pointer				:: vx1,vz1,xx1,zz1,xz1
	real,dimension(:,:,:),pointer				:: vx2,vz2,xx2,zz2,xz2
	real,dimension(:,:,:),pointer				:: dvx1,dvz1,dxx1,dzz1,dxz1
	real,dimension(:,:,:),pointer				:: dvx2,dvz2,dxx2,dzz2,dxz2
	real,dimension(:,:,:),pointer				:: drhox,drhoz,dlambda,dmu,dmu_xz
	real*8										:: dot1=0.,dot2=0.
	
	call sep_init ()
	
	
	nz=300
	nx=300
	ny=1
	dz=5.; dx=5.; dy=5.
	
	allocate(vx1(nz,nx,ny),vz1(nz,nx,ny),xx1(nz,nx,ny),zz1(nz,nx,ny),xz1(nz,nx,ny))
	allocate(vx2(nz,nx,ny),vz2(nz,nx,ny),xx2(nz,nx,ny),zz2(nz,nx,ny),xz2(nz,nx,ny))
	allocate(dvx1(nz,nx,ny),dvz1(nz,nx,ny),dxx1(nz,nx,ny),dzz1(nz,nx,ny),dxz1(nz,nx,ny))
	allocate(dvx2(nz,nx,ny),dvz2(nz,nx,ny),dxx2(nz,nx,ny),dzz2(nz,nx,ny),dxz2(nz,nx,ny))
	allocate(drhox(nz,nx,ny),drhoz(nz,nx,ny),dlambda(nz,nx,ny),dmu(nz,nx,ny),dmu_xz(nz,nx,ny))
	
	call random_number(drhox);call random_number(drhoz);call random_number(dlambda);call random_number(dmu);call random_number(dmu_xz)
	call random_number(vx1);call random_number(vz1);call random_number(xx1);call random_number(zz1);call random_number(xz1)
	call random_number(vx2);call random_number(vz2);call random_number(xx2);call random_number(zz2);call random_number(xz2)
	
	!Initializing imaging routine
	call full_elastic_imaging_init(nz, nx, ny, dz, dx, dy, twoD)
	
	!Applying forward
	call full_elastic_imaging_op(.false.,.false.,vx1(:,:,:),vz1(:,:,:),vx1(:,:,:),vz1(:,:,:),drhox,drhoz,dlambda,dmu,dmu_xz,dvx1,dvz1,dxx1,dzz1,dxz1)
	!Applying adjoint
	call adjoint_elastic_scattering_op(.false.,vx2(:,:,:),vz2(:,:,:),xx2(:,:,:),zz2(:,:,:),xz2(:,:,:),drhox,drhoz,dlambda,dmu,dmu_xz, dvx2, dvz2)
	dxx2=0.;dzz2=0.;dxz2=0.
	dot1=sum(vx2*dvx1+vz2*dvz1+xx2*dxx1+zz2*dzz1+xz2*dxz1)
	dot2=sum(vx1*dvx2+vz1*dvz2+xx1*dxx2+zz1*dzz2+xz1*dxz2)
	
	write(0,*)"dot1",dot1
	write(0,*)"dot2",dot2
	write(0,*)"absolute error",dot1-dot2
	write(0,*)"relative error",(dot1-dot2)/dot1

	call sep_close()
	call exit (0)

end program Dot_elastic_imaging 