program Imaging_cross

        use sep

        implicit none

        integer :: its
        integer :: nz2,nx2,nts
        real    :: oz,dz,ox,dx,ots,dts
        real,dimension(:,:,:),allocatable       :: swfld,rwfld
        real,dimension(:,:),allocatable         :: image
        real,dimension(:,:,:),allocatable       :: cumu_image,instant_image

        call sep_init(SOURCE)

        ! READ PARAMETERS
        call from_history("n1",nz2)
        call from_history("d1",dz)
        call from_history("o1",oz)

        call from_history("n2",nx2)
        call from_history("d2",dx)
        call from_history("o2",ox)

        call from_history("n3",nts)
        call from_history("d3",dts)
        call from_history("o3",ots)


        ! ALLOCATE
        allocate(swfld(nz2,nx2,nts))
        allocate(rwfld(nz2,nx2,nts))
        allocate(image(nz2,nx2))
        allocate(cumu_image(nz2,nx2,nts))
        allocate(instant_image(nz2,nx2,nts))

        !INITIALIZE IMAGES
        image = 0.0
        cumu_image = 0.0
        instant_image = 0.0

        !READ SOURCE AND RECEIVER WAVEFIELDS
        call sep_read(swfld)
        call sep_read(rwfld,"rwfld")

        do its = 1,nts
          instant_image(:,:,its) = swfld(:,:,its)*rwfld(:,:,its)
          image(:,:) = image(:,:) + instant_image(:,:,its)
          cumu_image(:,:,its) = image(:,:)
        end do


        call sep_write(image)
        call to_history("n1",nz2)
        call to_history("d1",dz)
        call to_history("o1",oz)
        call to_history("n2",nx2)
        call to_history("d2",dx)
        call to_history("o2",ox)
        call to_history("n3",1)
        call to_history("d3",1.0)
        call to_history("o3",0.0)

        call sep_write(cumu_image,"cumultative")
        call to_history("n1",nz2,"cumultative")
        call to_history("d1",dz,"cumultative")
        call to_history("o1",oz,"cumultative")
        call to_history("n2",nx2,"cumultative")
        call to_history("d2",dx,"cumultative")
        call to_history("o2",ox,"cumultative")
        call to_history("n3",nts,"cumultative")
        call to_history("d3",dts,"cumultative")
        call to_history("o3",ots,"cumultative")

        call sep_write(instant_image,"instant")
        call to_history("n1",nz2,"instant")
        call to_history("d1",dz,"instant")
        call to_history("o1",oz,"instant")
        call to_history("n2",nx2,"instant")
        call to_history("d2",dx,"instant")
        call to_history("o2",ox,"instant")
        call to_history("n3",nts,"instant")
        call to_history("d3",dts,"instant")
        call to_history("o3",ots,"instant")

        call sep_close()

end program Imaging_cross
