!Program for performing dot product test on propagation step module

program Prop_test_dot


	!Used modules 
	use sep
	use Prop_test_mod
	use dot_mod
	
	
	implicit none
	real								:: dz, dx, dy, dt
	integer								:: nz, nx, ny, nt, nv_pad
	logical								:: twoD
	real, dimension(:,:,:), pointer		:: vel
	
	parameter(nv_pad = 20)
	
	call sep_init (SOURCE)
	
	!Reading dimension of the model space (and data)
	call from_par("nz",nz)
	call from_par("nx",nx)
	call from_par("ny",ny)
	call from_par("nt",nt)
	call from_par("dz",dz)
	call from_par("dx",dx)
	call from_par("dy",dy)
	call from_par("dt",dt)
	
	
	if(ny .eq. 1) twoD = .true.
	allocate(vel(nz,nx,ny))
	call random_number(vel)
	vel = vel + 1500.
	
	
	
	!Calling the subroutines to perform dot product test
	call Prop_test_init(nz, nx, ny, nt, nv_pad, vel, dt, dz, dx, dy,twoD)
	write(0,*)"Dot product stepper"
	call dotp(Prop_test_call, nz*nx*ny*nt, nz*nx*ny*nt)
	write(0,*)" "
	write(0,*)"Dot product C5"
	call dotp(C5_call, nz*nx*ny, nz*nx*ny)
	write(0,*)" "
	write(0,*)"Dot product C2"
	call dotp(C2_call, nz*nx*ny, nz*nx*ny)
	write(0,*)" "
	write(0,*)"Dot product weight"
	call dotp(weight_call, nz*nx*ny, nz*nx*ny)
	write(0,*)" "
	write(0,*)"Dot product G"
	call dotp(G_call, nz*nx*ny, nz*nx*ny)

	
	call Prop_test_close()
	deallocate(vel)
	call sep_close()
	call exit (0)
	

end program Prop_test_dot
