!Program for performing dot product test on S and D module for non-constant density Born/RTM operators

program S_D_prog


	!Used modules 
	use sep
	use dot_mod
	use S_mod
	!use D8pt_mod
	use D10pt_mod
	
	
	implicit none
	real								:: dz, dx, dy
	integer								:: nz, nx, ny
	logical								:: twoD
	
	call sep_init (SOURCE)
	
	!Reading dimension of the model space (and data)
	call from_par("nz",nz)
	call from_par("nx",nx)
	call from_par("ny",ny)
	call from_par("dz",dz)
	call from_par("dx",dx)
	call from_par("dy",dy)
	
	if(ny .eq. 1) then
		twoD = .true.
	else
		twoD = .false.
	endif
	
	
	!Calling the subroutines to perform dot product test
	call S_init(nz, nx, ny, twoD)
	write(0,*)"Testing Sz"
	call dotp(Sz_call, nz*nx*ny, nz*nx*ny)
	write(0,*)""
	write(0,*)"Testing Sx"
	call dotp(Sx_call, nz*nx*ny, nz*nx*ny)
	write(0,*)""
	if(.not. twoD) then
		write(0,*)"Testing Sy"
		call dotp(Sy_call, nz*nx*ny, nz*nx*ny)
		write(0,*)""
	endif
	
	!call D8pt_init(nz,nx,ny,dz,dx,dy,twoD)
	call D10pt_init(nz,nx,ny,dz,dx,dy,twoD)
	write(0,*)"Forward difference Dp"
	write(0,*)"Testing Dpz8/10pt"
	call dotp(Dpz_call, nz*nx*ny, nz*nx*ny)
	write(0,*)""
	write(0,*)"Testing Dpx8/10pt"
	call dotp(Dpx_call, nz*nx*ny, nz*nx*ny)
	write(0,*)""
	if(.not. twoD) then
		write(0,*)"Testing Dpy8/10pt"
		call dotp(Dpy_call, nz*nx*ny, nz*nx*ny)
		write(0,*)""
	endif
	
	write(0,*)"Backward difference Dm"
	write(0,*)"Testing Dmz8/10pt"
	call dotp(Dmz_call, nz*nx*ny, nz*nx*ny)
	write(0,*)""
	write(0,*)"Testing Dmx8/10pt"
	call dotp(Dmx_call, nz*nx*ny, nz*nx*ny)
	write(0,*)""
	if(.not. twoD) then
		write(0,*)"Testing Dmy8/10pt"
		call dotp(Dmy_call, nz*nx*ny, nz*nx*ny)
		write(0,*)""
	endif
	
	!call D8pt_close()
	call D10pt_close()
	call sep_close()
	call exit (0)
	

end program S_D_prog
