!!$=head1 NAME
!!$
!!$Stack2d_elastic - function for stacking partial elastic 2D images
!!$
!!$=head1 SYNOPSIS
!!$
!!$Stack2d_elastic.x < input.H > output.H
!!$
!!$=head1 DESCRIPTION
!!$
!!$Program for stacking partial 2d images
!!$
!!$=head1 PARAMETERS
!!$
!!$=over 3
!!$
!!$=item from par
!!$
!!$
!!$
!!$=back
!!$
!!$
!!$=cut
!%
program Stack2d_elastic

	!Used modules
	use sep

	!Variable declaration
	implicit none
	!Input variables
	integer  		    											:: n1, n2, n3, n4, n5
	integer*8															:: bytes
	real																	:: o1, o2, o3, o4, o5, d1, d2, d3, d4, d5
	!Internal variables
	real, dimension(:,:,:), allocatable		:: output,input
	integer												        :: wc, srite, rc, sreed, iz, ix, ip, is

	call sep_init (SOURCE)
	!reading from input file and writing header to output file
	call from_history("n1",n1)
	call from_history("o1",o1)
	call from_history("d1",d1)
	call to_history("n1",n1)
	call to_history("o1",o1)
	call to_history("d1",d1)
	call from_history("n2",n2)
	call from_history("o2",o2)
	call from_history("d2",d2)
	call to_history("n2",n2)
	call to_history("o2",o2)
	call to_history("d2",d2)
	call from_history("n3",n3)
	call to_history("n3",n3)
	call to_history("o3",1.)
	call to_history("d3",1.)
	call from_history("n4",n4)
	call to_history("n4",1)
	!allocate memory for random number
	allocate(input(n1,n2,n3))
	allocate(output(n1,n2,n3))
	output= 0.0
	bytes=n1*n2
	bytes=bytes*n3

	do is=1,n4
		input = 0.0
		!Reading input file
		rc=sreed("in", input, bytes*4)
		!$OMP PARALLEL DO private(iz,ix,ip)
		do ip=1,n3
			do ix=1,n2
				do iz=1,n1
					output(iz,ix,ip)=output(iz,ix,ip)+input(iz,ix,ip)
				enddo
			enddo
		enddo
		!$OMP END PARALLEL DO
	enddo

	!Writing output
	wc=srite("out", output, bytes*4)

	!closing statements
	deallocate(output,input)
	call sep_close()
	call exit (0)

end program Stack2d_elastic
