!!$=head1 NAME
!!$
!!$Stack2d_extended - function for stacking partial extended 2D images (NOT WORKING!)
!!$
!!$=head1 SYNOPSIS
!!$
!!$Stack2d_elastic.x input[...].H > output.H n1= n2= n3=
!!$
!!$=head1 DESCRIPTION
!!$
!!$Program for stacking partial 2d extended images
!!$
!!$=head1 PARAMETERS
!!$
!!$=over 3
!!$
!!$=item from par
!!$
!!$
!!$
!!$=back
!!$
!!$
!!$=cut
!%
program Stack2d_extended

	!Used modules
	use sep

	!Variable declaration
	implicit none
	!Input variables
	integer  		    											:: n1, n2, n3, n4, n5, iarg, n3_buffer=101
	integer*8															:: bytes, wc, srite, rc, sreed, bytes_toproc
	real																	:: o1, o2, o3, o4, o5, d1, d2, d3, d4, d5
	!Internal variables
	real, dimension(:,:,:), allocatable		:: output
	real, dimension(:,:,:,:), allocatable		:: input
	integer												        :: iz, ix, ip, is, n3_toproc
	character(len=128) 										:: arg

	call sep_init (SOURCE)
	!reading from input file and writing header to output file
	call getarg(1, arg)
	call from_aux(arg,"n1",n1)
	call from_aux(arg,"o1",o1)
	call from_aux(arg,"d1",d1)
	call from_aux(arg,"n2",n2)
	call from_aux(arg,"o2",o2)
	call from_aux(arg,"d2",d2)
	call from_aux(arg,"n3",n3)
	call from_aux(arg,"o3",o3)
	call from_aux(arg,"d3",d3)
	call to_history("n1",n1)
	call to_history("o1",o1)
	call to_history("d1",d1)
	call to_history("n2",n2)
	call to_history("o2",o2)
	call to_history("d2",d2)
	call to_history("n3",n3)
	call to_history("o3",o3)
	call to_history("d3",d3)
	call to_history("n4",1)
	!allocate memory for random number
	allocate(input(n1,n2,n3,3))
	allocate(output(n1,n2,n3))
	output= 0.0
	bytes=n1*n2
	bytes=4*bytes


	do iarg =  1,iargc()
		call getarg(iarg, arg)
		call from_aux(arg,"n4",n4) !number of shots per file
		input = 0.0
		write(0,*)"stacking file:",arg
		call sep_read(input,arg)
		do is=1,n4
			!Reading input file
			! n3_toproc = n3
			! ip = 1
			! do while (n3_toproc .gt. 0)
			! 	if (n3_buffer .le. n3_toproc) then
			! 		bytes_toproc = n3_buffer*bytes
			! 		n3_toproc = n3_toproc - n3_buffer
			! 	else
			! 		bytes_toproc = n3_toproc*bytes
			! 		n3_toproc = 0
			! 	endif
			! 	if(sreed(arg, input(:,:,ip), bytes_toproc) .ne. bytes_toproc) call  erexit("ERROR READING VELOCITY PERTURBATION")
			! 	ip = ip + n3_buffer
			! enddo
			!$OMP PARALLEL DO private(iz,ix,ip) shared(is)
			do ip=1,n3
				do ix=1,n2
					do iz=1,n1
						output(iz,ix,ip)=output(iz,ix,ip)+input(iz,ix,ip,is)
					enddo
				enddo
			enddo
			!$OMP END PARALLEL DO
		enddo
	enddo

	!Writing output
	! n3_toproc = n3
	! ip = 1
	! do while (n3_toproc .gt. 0)
	! 	if (n3_buffer .le. n3_toproc) then
	! 		bytes_toproc = n3_buffer*bytes
	! 		n3_toproc = n3_toproc - n3_buffer
	! 	else
	! 		bytes_toproc = n3_toproc*bytes
	! 		n3_toproc = 0
	! 	endif
	! 	if(srite("out", output(:,:,ip), bytes_toproc) .ne. bytes_toproc) call  erexit("ERROR WRITING VELOCITY PERTURBATION")
	! 	ip = ip + n3_buffer
	! enddo
	call sep_write(output)

	!closing statements
	deallocate(output,input)
	call sep_close()
	call exit (0)

end program Stack2d_extended
