#!/usr/bin/python
import sep_python as sep # import sep functions
import sys

if __name__ == '__main__':
	if(len(sys.argv) == 1):
		print "NAME \n"
		print "	Elastic_data_pressure.py - creates elastic data file formated for Propagator_elastic from pressure data \n"
		print "SYNOPSIS"
		print "	Elastic_data_pressure input=data.H output=elastic_pressure_data.H \n"
		print "DESCRIPTION"
		print "	Takes the scalar pressure data file and forms elastic data for propagation:"
		print "	-Data format n1=time n2=receiver-number n3=shot-number"
		print "INPUT PARAMETERS"
		print "	None"
		print ""
	else:
		[pars,files]=sep.parse_args(sys.argv)
		input_file=sep.from_cmd_line("input") 
		output_file=sep.from_cmd_line("output") 
		#Getting number of shots from input file
		n_shots=int(sep.RunShellCmd_output("Get <%s n3 parform=n"%(input_file)))
		#Creating elastic data format for propagator
		tmp_file=sep.tmp_file("tmp_elastic_data.H")
		for ishot in range(0,n_shots):
			cmd="Window3d <%s n3=1 f3=%s | Pad end3=1 extend=1 | Transp plane=23 | Pad end2=3  > %s%s"%(input_file,ishot,tmp_file,ishot)
			sep.RunShellCmd(cmd)
		cmd="Cat `ls %s* | sort -V` axis=4 >%s"%(tmp_file,output_file)
		sep.RunShellCmd(cmd)
		sep.Rm(tmp_file+"*")
	