#!/bin/bash

if [ $# -gt 0 ]; then
    file=$1
    sx=$2
    sy=$3
    sz=$4
    gx=$5
    gy=$6
    gz=$7
    Dis3dhead <$file key_list=$sx:$sy:$sz |& grep -v number | awk '!($1="")' | sort -n | uniq >$8/sou_pos.p
    Dis3dhead <$file key_list=$gx:$gy:$gz |& grep -v number | awk '!($1="")' | sort -n | uniq >$8/rec_pos.p
else
    echo "NAME
    Geometry.sh - creates source and receiver geometry files for wave propagator

SYNOPSIS
    Geometry Data.H sx sy sz gx gy gz path

DESCRIPTION
    Take the geometry information from the header of the Data.H and create two file:
    -sou_pos.p (file containing x,y,z of all the sources present in the header)
    -rec_pos.p (file containing x,y,z of all the receivers present in the header)

INPUT PARAMETERS
    sx,sy,sz -char
               name of the header entries for x,y,z source position (NOTE: positive z)
    gx,gy,gz -char
               name of the header entries for x,y,z receiver position (NOTE: positive z)
    path -char
               path of the directory where to write the two ouput files"
fi
