#!/usr/bin/env python
#Stacking command for extended images
import sys,os
sys.path.append(os.environ.get('REPOSITORY')+"/python_solver/python_modules")
import sep_util as sep
import numpy as np

if __name__ == '__main__':
    if(len(sys.argv) == 1):
        print("NAME \n")
        print("	Stack2d_extended - Stacking operator for large extended images \n")
        print("SYNOPSIS")
        print("	Stack2d_extended.py input1.H [...] output.H \n")
        print("DESCRIPTION")
        print("	Stacks inputs files and places the result in output.H \n")
    else:
        input_files=sys.argv[1:-1]
        output_file=sys.argv[-1]
        axis_info = sep.get_axes(input_files[0])
        n_axis = sep.get_num_axes(input_files[0])
        shape = [ii[0] for ii in axis_info]
        shape = shape[:n_axis]
        output=np.zeros(np.prod(shape[:-1]))
        size_image=output.size
        #Reading input files iteratively
        for ifile in input_files:
            print("Stack image file %s"%(ifile))
            fid = open(sep.get_binary(ifile),'r+b')
            axis_info = sep.get_axes(ifile)
            n_axis = sep.get_num_axes(ifile)
            nshots = axis_info[3][0]
            image = np.fromfile(fid, dtype='>f')
            for ii in range(nshots):
                index=(ii*size_image)
                output+=image[index:index+size_image]
            fid.close()
        #Writing output
        sep.write_file(output_file,output,axis_info[0:3])
