#!/usr/bin/python
#Analytical solution for plane-wave case (1D solution)
import math as mt 
import struct
import commands
import array
import sys
sys.path.insert(0, '../script/')
from Mine_function import convolution
rho1=1000.0; #kg/m^3
rho2=750.0; #kg/m^3
bulk=2.2;#GPa
v1=mt.sqrt(bulk*mt.pow(10,9)/rho1);
v2=mt.sqrt(bulk*mt.pow(10,9)/rho2);
I1=rho1*v1;
I2=rho2*v2;
#reflection coefficient
R=(I1-I2)/(I1+I2)
#trasmission coefficient
T=2*I2/(I1+I2)

#Reading wavelet
stat,n1=commands.getstatusoutput('In before.H | grep n1 | colrm 1 3 | awk \'{print $1;}\'');
stat,o1=commands.getstatusoutput('In before.H | grep n1 | colrm 1 17 | awk \'{print $1;}\'');
stat,d1=commands.getstatusoutput('In before.H | grep n1 | colrm 1 31 | awk \'{print $1;}\'');
n1 = int(n1)
o1 = int(o1)
d1 = float(d1)
f = open('/net/gertie/scr1/ettore/before.H@','rb')
data = []
for i in range(n1):
	data.append(struct.unpack('>f',f.read(4))[0])
f.close

#creating the analytical solution
dt = 0.004 #s
dx = 7 #m
depth_s = 476.37;
interface = 800.0;
t0 = (interface - depth_s)/v1
tbefore = 0.4 #[s]
tafter = 0.84 #[s]
delta_time = tafter -(tbefore+t0)
space1 = delta_time*v1 #m
space2 = delta_time*v2 #m
pos1 = (interface-space1)/dx
w1= pos1-int(pos1)
pos2 = (interface+space2)/dx
w2= pos2-int(pos2)
impulse = []
for i in range(len(data)):
	impulse.append(0.0)
impulse[int(pos1)]=(1.-w1)*R
impulse[int(pos1+1)]=w1*R
impulse[int(pos2)]=(1.-w2)*T
impulse[int(pos2+1)]=w2*T
analytical=convolution(data,impulse)
print (interface-space1),(interface+space2)

first = 108;
last = 325;
print len(data),len(analytical[first:last])
#write binary file
with open('/net/gertie/scr1/ettore/plane_analytical.H@', 'wb') as f:
    for b in analytical[first:last]:
        f.write(struct.pack('>f', b))
#writing header/pointer file
f = open('plane_analytical.H','w')
f.write('in=/net/gertie/scr1/ettore/plane_analytical.H@ \n')
f.write('n1='+str(n1)+'\n')
f.write('o1='+str(o1)+'\n')
f.write('d1='+str(d1)+'\n')
f.write('label1=\'x [m]\'\n')
f.write('label2=Amplitude \n')






