#!/bin/bash

if [ $# -gt 0 ]; then
    pid_freeze=$1
    pid_check=$2
    kill -TSTP $pid_freeze
    while [ -e /proc/$pid_check ]; 
    	do 
    	sleep 0.1
    done
    kill -CONT $pid_freeze
else
    echo "NAME
    freeze_pid.sh - suspend process until other provided process has finished

SYNOPSIS
    freeze_pid.sh pid_to_freeze pid_to_wait

DESCRIPTION
    Takes a PID and suspend the associated process until another supplied process has been completed

INPUT PARAMETERS
    pid_to_freeze -int
               PID of the process to suspend
    pid_to_wait -int
               PID of the process to wait"
fi