#!/usr/bin/python
import sep_python as sep
import operator_obj as op 
import sys
import os as os_sys
import re
from python_solver_outcore import write_log_file 
from timeit import default_timer as timer

##########################################################################################	
################################ MAIN ####################################################	
##########################################################################################	

if __name__ == '__main__':
##########################################################################################		
############################### VPTFWI MAIN  #############################################
##########################################################################################
	
	if (len(sys.argv) == 1):
        	# write self documentation	
		print 'self doc' 

	else:

		########################## DISGUSTING PLUMBING STUFF #############################
		# get the path to the solver
		python_path_list = os_sys.environ['PYTHONPATH'].split(":")
		indx = [i for i, s in enumerate(python_path_list) if '/python_solver' in s]
		pathsource = python_path_list[indx[0]]		
		
		l_solver = 	pathsource+"/generic_linear_prob.py"	
		l_solver_backslash = l_solver.replace("/","\/")	

		# GET CURRENT DIRECTORY
		cwd = os_sys.getcwd()+"/"

		# PARSING STEPS

		# 1: modifies the parfile of the nonlinear vptfwi
		# 	- creates the correct vp inversion folder name
		#	- creates the correct vp inversion inverted model name
		#   - creates the correct vp inversion suffix
		
		# 2: spits out the name of the inverted model after VP inversion
	
		# 3. spits out the name of the vp unpreconditioned inverted model 	 
		
		# 4. automatically pick and spit out the name of the optimal inverted model for nonlinear update
		
		step = int(sep.from_cmd_line("step"))
		
		########################## READ PARAMETERS FROM COMMAND LINE #################

		# read work directory name
		main_wrk_dir = sep.from_cmd_line("main_wrk_dir")	

		# read main log file name
		main_log_file = sep.from_cmd_line("main_log_file")

		# read main suffix name
		main_suffix = sep.from_cmd_line("main_suffix")		

		########################## PARSE MAIN LOG FILE ###############################

		########### get the nonlinear iteration number
		out = sep.RunShellCmd_output("grep iter %s | tail -1"%(main_wrk_dir+"/"+main_log_file))
		string_expression = re.compile("iter = ([-+]?[0-9]*\.?[0-9]+([eE][-+]?[0-9]+)?)")
		find = string_expression.search(out)

		if find:
			iteration = find.group(1)
					
		# if not found: we are at the first iteration 
		else: 
			iteration = 0
			
		# convert iteration to a number
		iteration = int(iteration)

		########### get the number of the tested points

		# list all the subfolders for this iteration value and get the number of folders
		cmd = "ls -ld %s/vp_inversion_it%s_point* | wc -l" %(main_wrk_dir,iteration)
		nb_folders = int(sep.RunShellCmd_output(cmd))
		
		if (step == 1):

			############################### CASE 1 #######################################
			# MODIFIES THE NONLINEAR PARFILE OF THE VPTFWI INVERSION TO CREATE THE 
			# CORRECT VP INVERSION FOLDER NAME, INVERTED VP MODEL NAME AND SUFFIX
			##############################################################################
		
			# check if you are in the case where you shrink the step length
			# in that case, remove inversion folders for points 1,2 and 3
			if ( (nb_folders == 4) or (nb_folders == 3 and iteration != 0) ):

				# folder for point 1 
				cmd = "Rm %s/vp_inversion_it%s_point1/*.H" %(main_wrk_dir,iteration)
				sep.RunShellCmd(cmd)
				cmd = "rm -rf %s/vp_inversion_it%s_point1" %(main_wrk_dir,iteration)
				sep.RunShellCmd(cmd)

				# folder for point 2 
				cmd = "Rm %s/vp_inversion_it%s_point2/*.H" %(main_wrk_dir,iteration)
				sep.RunShellCmd(cmd)
				cmd = "rm -rf %s/vp_inversion_it%s_point2" %(main_wrk_dir,iteration)
				sep.RunShellCmd(cmd)
				
				# folder for point 3 
				cmd = "Rm %s/vp_inversion_it%s_point3/*.H" %(main_wrk_dir,iteration)
				sep.RunShellCmd(cmd)
				cmd = "rm -rf %s/vp_inversion_it%s_point3" %(main_wrk_dir,iteration)
				sep.RunShellCmd(cmd)	

				# instead of reparsing the number of folders, update it directly
				if (iteration == 0):
					nb_folders = 1
				else:			
					nb_folders = 0
					
			# check if you are at iteration 0 and you haven't computed Vp_inversion_it0_point0
			if (iteration == 0): 
				if (nb_folders == 0):
					point = 0
				else:
					point = nb_folders 
					
			else:
				point = nb_folders + 1
								
			##################### CREATE NAMES AND WRITE IT ON PARFILE ###################

			# creating the vp inversion folder name
			vp_inversion_folder = main_wrk_dir+"/vp_inversion_it%s_point%s" %(iteration,point)

			# creating the vp inversion suffix
			vp_inv_suffix = main_suffix+"_vp_inversion_it%s_point%s" %(iteration,point)			 

			# create vp inversion inverted model name
			vp_inverted_model = main_suffix+"_vp_inverted_it%s_point%s.pad.H" %(iteration,point)

			# print the results on the parfile
			sys.stdout.write("wrk_dir=%s suffix=%s inv_model=%s" %(vp_inversion_folder,vp_inv_suffix,vp_inverted_model))
			sys.stdout.flush()

			############################### FINISHED CASE 1 ##############################

		if (step == 2):					

			############################### CASE 2 #######################################
			# SCRIPT SPITS OUT THE NAME OF THE VP INVERTED MODEL AFTER VP INVERSION
			# BEFORE UNPRECONDITIONING
			##############################################################################				

			if (iteration == 0):
				point = nb_folders - 1 

			else:
				point = nb_folders	

			# creating the vp inversion folder name
			vp_inversion_folder = main_wrk_dir+"/vp_inversion_it%s_point%s" %(iteration,point)

			# create vp inversion inverted model name
			vp_inverted_model = main_suffix+"_vp_inverted_it%s_point%s.pad.H" %(iteration,point)	

			# get the name of the inverted vp model
			vp_inverted_model_output = cwd+vp_inversion_folder+"/"+vp_inverted_model
			
			# print the result on the parfile
			sys.stdout.write("%s" %(vp_inverted_model_output))
			sys.stdout.flush()
			
			############################### FINISHED CASE 2 ##############################

		if (step == 3):					

			############################### CASE 3 #######################################
			# SCRIPT SPITS OUT THE NAME OF THE VP UNPRECONDITIONED INVERTED MODEL
			##############################################################################				
			if (iteration == 0):
				point = nb_folders - 1 
				
			else:
				point = nb_folders	

			# creating the vp inversion folder name
			vp_inversion_folder = main_wrk_dir+"/vp_inversion_it%s_point%s" %(iteration,point)

			# create vp inversion inverted model name
			vp_inverted_model_unprec = main_suffix+"_vp_inverted_it%s_point%s.unprec.pad.H" %(iteration,point)	

			# get the name of the inverted vp model
			vp_inverted_model_unprec_output = cwd+vp_inversion_folder+"/"+vp_inverted_model_unprec
			
			# print the result on the parfile
			sys.stdout.write("%s" %(vp_inverted_model_unprec_output))
			sys.stdout.flush()
			
			############################### FINISHED CASE 3 ##############################

		if (step == 4):					

			############################### CASE 4 #######################################
			# SCRIPT PICKS AND SPITS OUT VP INVERTED MODEL FOR PICKED STEP LENGTH
			# THIS INVERTED MODEL WILL BE USED FOR GRADIENT COMPUTATION
			##############################################################################				
	
			# parse last line of main log file where the optimal model point is chosen
			out = sep.RunShellCmd_output("grep best step-length %s | tail -1"%(main_wrk_dir+"/"+main_log_file))
		
			# case where point 1 is optimal
			if ("c1" in out):

				# optimal point is 1				
				point = 1
			
				# creating the vp inversion folder name
				vp_inversion_folder = main_wrk_dir+"/vp_inversion_it%s_point%s" %(iteration,point)

				# create vp inversion inverted model name
				vp_inverted_model_unprec = main_suffix+"_vp_inverted_it%s_point%s.unprec.pad.H" %(iteration,point)	

				# get the name of the inverted vp model
				vp_inverted_model_unprec_output = cwd+vp_inversion_folder+"/"+vp_inverted_model_unprec

				# print the result on the parfile
				sys.stdout.write("%s" %(vp_inverted_model_unprec_output))
				sys.stdout.flush()		
		
			# case where point 2 is optimal
			elif ("c2" in out):
		
				# optimal point is 2				
				point = 2
			
				# creating the vp inversion folder name
				vp_inversion_folder = main_wrk_dir+"/vp_inversion_it%s_point%s" %(iteration,point)

				# create vp inversion inverted model name
				vp_inverted_model_unprec = main_suffix+"_vp_inverted_it%s_point%s.unprec.pad.H" %(iteration,point)		

				# get the name of the inverted vp model
				vp_inverted_model_unprec_output = cwd+vp_inversion_folder+"/"+vp_inverted_model_unprec

				# print the result on the parfile
				sys.stdout.write("%s" %(vp_inverted_model_unprec_output))
				sys.stdout.flush()					

			# case where parabola minimum is optimal
			elif ("minimum" in out):
					
				# optimal point is 3				
				point = 3
			
				# creating the vp inversion folder name
				vp_inversion_folder = main_wrk_dir+"/vp_inversion_it%s_point%s" %(iteration,point)

				# create vp inversion inverted model name
				vp_inverted_model_unprec = main_suffix+"_vp_inverted_it%s_point%s.unprec.pad.H" %(iteration,point)		

				# get the name of the inverted vp model
				vp_inverted_model_unprec_output = cwd+vp_inversion_folder+"/"+vp_inverted_model_unprec

				# print the result on the parfile
				sys.stdout.write("%s" %(vp_inverted_model_unprec_output))
				sys.stdout.flush()
				
			else:
				
				# in this case, we are at iteration 0 and we are computing the first gradient
				# optimal point is 0 (very first time we compute the gradient)
				point = 0
			
				# creating the vp inversion folder name
				vp_inversion_folder = main_wrk_dir+"/vp_inversion_it%s_point%s" %(iteration,point)

				# create vp inversion inverted model name
				vp_inverted_model_unprec = main_suffix+"_vp_inverted_it%s_point%s.unprec.pad.H" %(iteration,point)		

				# get the name of the inverted vp model
				vp_inverted_model_unprec_output = cwd+vp_inversion_folder+"/"+vp_inverted_model_unprec

				# print the result on the parfile
				sys.stdout.write("%s" %(vp_inverted_model_unprec_output))
				sys.stdout.flush()			
				
			############################### FINISHED CASE 4 ##############################


