program dot_prod_wemva

	use sep

  	implicit none

  	integer              						:: nz,nx,hzmax,hxmax,htmax,nhz,nhx,nht
  	real										:: dot1,dot2,error
	real,dimension(:,:),allocatable   			:: mod1,rmod
	real,dimension(:,:,:,:,:),allocatable   	:: dat1,rdat

  	call sep_init()
  	
	call from_param("nz",nz)
	call from_param("nx",nx)
	call from_param("hzmax",hzmax)
	call from_param("hxmax",hxmax)
	call from_param("htmax",htmax)		
	
	nhz = 2 * hzmax + 1
	nhx = 2 * hxmax + 1
	nht = 2 * htmax + 1
	
	allocate(mod1(nz,nx))
	allocate(rmod(nz,nx))
	call sep_read(mod1)
	call sep_read(rmod,"rmod")

	allocate(rdat(nz,nx,nhz,nhx,nht))	
	allocate(dat1(nz,nx,nhz,nhx,nht))	
	call sep_read(dat1,"dat1")
	call sep_read(rdat,"rdat")
	
	dot1 = sum(mod1*rmod)
	dot2 = sum(dat1*rdat)
	
	error = (dot1-dot2)/dot2
	
	write(0,*) "dot1",dot1
	write(0,*) "dot2",dot2
	write(0,*) "error",error	
		
	call sep_close()					
	
end program