program gen_rand_mod_born

	use sep

  	implicit none

  	integer              					:: nz2,nx2,nz,nx,nhz,nhx,nht,hzmax,hxmax,htmax,nts,nr,ns
	integer									:: z_pad,x_pad
  	real									:: ots,dts,or,dr,os,ds
  	real									:: oz,dz,ox,dx,oh,dhz,dhx,dht
	real,dimension(:,:,:),allocatable   	:: data
	real,dimension(:,:,:,:,:),allocatable   :: model

  	call sep_init()
  	
	call from_param("nz",nz)
	call from_param("nx",nx)	
	call from_param("z_pad",z_pad)
	call from_param("x_pad",x_pad)	
	call from_param("hzmax",hzmax)	
	call from_param("hxmax",hxmax)	
	call from_param("htmax",htmax)			
	call from_param("nts",nts)
	call from_param("nr",nr)
	call from_param("ns",ns)		
	call from_param("os",os)
	call from_param("ds",ds)
	call from_param("or",or)
	call from_param("dr",dr)		
	call from_param("dts",dts)
	call from_param("dz",dz)		
	call from_param("dx",dx)
	
  	nz2 = nz + 2 * z_pad
  	nx2 = nx + 2 * x_pad		
	
	nhz = 2 * hzmax + 1 
	dhz = dz

	nhx = 2 * hxmax + 1 
	dhx = dx

	nht = 2 * htmax + 1 
	dht = dts
	
	allocate(model(nz2,nx2,-hzmax:hzmax,-hxmax:hxmax,-htmax:htmax))	
	allocate(data(nts,nr,ns))
	
	call random_number(model)
	call random_number(data)
	
	call sep_write(model)

	call to_history("n1",nz2)
	call to_history("o1",0.0)
	call to_history("d1",1.0)

	call to_history("n2",nx2)
	call to_history("o2",0.0)
	call to_history("d2",1.0)

	call to_history("n3",nhz)
	call to_history("o3",0.0)
	call to_history("d3",1.0)

	call to_history("n4",nhx)
	call to_history("o4",0.0)
	call to_history("d4",1.0)
	
	call to_history("n5",nht)
	call to_history("o5",0.0)
	call to_history("d5",1.0)
	
	call sep_write(data,"data")

	call to_history("n1",nts,"data")
	call to_history("d1",dts,"data")
	call to_history("o1",0.0,"dat")	
	
	call to_history("n2",nr,"data")
	call to_history("d2",dr,"data")
	call to_history("o2",or,"data")		

	call to_history("n3",ns,"daat")
	call to_history("d3",ds,"data")
	call to_history("o3",or,"data")		
			
	call sep_close()					
	
end program