program gen_rand_mod_wemva

	use sep

  	implicit none

  	integer              					:: nz2,nx2,nz,nx,nh,nts,nr,ns
  	integer									:: nhz,nhx,nht
	integer									:: hzmax,hxmax,htmax
	integer									:: z_pad,x_pad
  	real									:: ots,dts,or,dr,os,ds
  	real									:: oz,dz,ox,dx
  	real									:: ohz,ohx,oht,dhz,dhx,dht
  	real									:: oz_true,ox_true
	real,dimension(:,:),allocatable   		:: model
	real,dimension(:,:,:,:,:),allocatable   :: data	
	

  	call sep_init()
  	
	call from_param("nz",nz)
	call from_param("nx",nx)	
	call from_param("z_pad",z_pad)
	call from_param("x_pad",x_pad)	
	call from_param("hzmax",hzmax,0)	
	call from_param("hxmax",hxmax,0)	
	call from_param("htmax",htmax,0)			
	call from_param("dz",dz)		
	call from_param("dx",dx)
	
  	nz2 = nz + 2 * z_pad
  	nx2 = nx + 2 * x_pad		
	
	nhz = 2 * hzmax + 1 
	dhz = dz

	nhx = 2 * hxmax + 1 
	dhx = dx

	nht = 2 * htmax + 1 
	dht = dts

	allocate(model(nz2,nx2))
	allocate(data(nz2,nx2,-hzmax:hzmax,-hxmax:hxmax,-htmax:htmax))	
	
	call random_number(model)
	call random_number(data)
	
	call sep_write(model)

	call to_history("n1",nz2)
	call to_history("o1",0.0)
	call to_history("d1",1.0)

	call to_history("n2",nx2)
	call to_history("o2",0.0)
	call to_history("d2",1.0)
	
	call sep_write(data,"data")

	call to_history("n1",nz2,"data")
	call to_history("o1",0.0,"data")
	call to_history("d1",1.0,"data")

	call to_history("n2",nx2,"data")
	call to_history("o2",0.0,"data")
	call to_history("d2",1.0,"data")

	call to_history("n3",nhz,"data")
	call to_history("o3",0.0,"data")
	call to_history("d3",1.0,"data")

	call to_history("n4",nhx,"data")
	call to_history("o4",0.0,"data")
	call to_history("d4",1.0,"data")
	
	call to_history("n5",nht,"data")
	call to_history("o5",0.0,"data")
	call to_history("d5",1.0,"data")	

				
	call sep_close()					
	
end program