program im_cond_wemva_dpt

	use sep
	use im_cond_wemva

	implicit none

	integer                               		:: nz2,nx2,nt
	integer                                		:: hxmax,hzmax,htmax
	real*8								  		:: dot1,dot2
	real*8,dimension(:,:,:),allocatable   		:: data1,data2,recv_wfld
	real*8,dimension(:,:,:,:,:),allocatable		:: model1,model2
	integer										:: c_1,c_2
	real										:: cr

	call sep_init()

	call from_param("nz",nz2)
	call from_param("nx",nx2)
	call from_param("nt",nt)
	call from_param("hxmax",hxmax)
	call from_param("hzmax",hzmax)	
	call from_param("htmax",htmax)

	allocate(data1(nz2,nx2,nt))
	allocate(data2(nz2,nx2,nt))	
	allocate(model1(nz2,nx2,-hzmax:hzmax,-hxmax:hxmax,-htmax:htmax))
	allocate(model2(nz2,nx2,-hzmax:hzmax,-hxmax:hxmax,-htmax:htmax))
	allocate(recv_wfld(nz2,nx2,nt))	

	call random_number(recv_wfld)
	call random_number(model1)
	call random_number(data2)

	call im_cond_wemva_init(nz2,nx2,hzmax,hxmax,htmax,nt,recv_wfld)

	call system_clock(count_rate=cr)
  	call system_clock(c_1)

	call im_cond_wemva_op2(.false.,.false.,model1,data1)
	call im_cond_wemva_op2(.true.,.false.,model2,data2)	

  	call system_clock(c_2)
  	write(0,'(a,f10.1,a)') "time spent computing: ",(c_2-c_1)/cr," [s]"  

	dot1 = sum(model1*model2)
	dot2 = sum(data1*data2)		
	
	write(0,*) dot1
	write(0,*) dot2

	write(0,*) "error1", (dot1-dot2)/dot1

	call sep_close()

end program