program norm_trace_linear_main

	use sep

	implicit none	
	
	integer									:: nts,nr,ns,ir,is
	real									:: ots,or,os,dts,dr,ds
	real,dimension(:,:),allocatable			:: model,data,predicted_data
	integer(8)							    :: srite,sreed,wc,rc,nbytes
	real*8									:: dot,norm,norm_model
		
	call sep_init(SOURCE)	
	
	! READ PARAMETERS 
	call from_history("n1",nts)
 	call from_history("d1",dts)	
 	call from_history("o1",ots)
 	
 	call from_history("n2",nr)
 	call from_history("d2",dr)	
 	call from_history("o2",or) 

 	call from_history("n3",ns)
 	call from_history("d3",ds)	
 	call from_history("o3",os)
 	
 	nbytes = 4 * nr * nts

	allocate(model(nts,nr))
	allocate(data(nts,nr))	
	allocate(predicted_data(nts,nr))
 	
	do is = 1,ns

		model = 0.0
		data = 0.0
		predicted_data = 0.0
		
		rc = sreed("in",model,nbytes)
		rc = sreed("predicted_data",predicted_data,nbytes)

		do ir = 1,nr

			! compute norm
			norm = norm2(predicted_data(:,ir))
			dot = dot_product(predicted_data(:,ir),model(:,ir))
			
			if (norm .gt. 0.0) then

				data(:,ir) = model(:,ir)/norm
				data(:,ir) = data(:,ir) - dot/(norm*norm*norm)*predicted_data(:,ir)

			end if

		end do

		wc = srite("out",data,nbytes)

	end do	 											
			
	! WRITE PARAMETERS 
	call to_history("n1",nts)
 	call to_history("d1",dts)	
 	call to_history("o1",ots)
 	
 	call to_history("n2",nr)
 	call to_history("d2",dr)	
 	call to_history("o2",or) 

 	call to_history("n3",ns)
 	call to_history("d3",ds)	
 	call to_history("o3",os)

	deallocate(model)
	deallocate(data)
	deallocate(predicted_data)	

 	call sep_close()

end program