program norm_trace_nonlinear_main

	use sep

	implicit none	
	
	integer									:: nts,nr,ns,ir,is
	real									:: ots,or,os,dts,dr,ds,norm
	real,dimension(:,:),allocatable			:: model,data
	integer(8)							    :: srite,sreed,wc,rc,nbytes
		
	call sep_init(SOURCE)	
	
	! READ PARAMETERS 
	call from_history("n1",nts)
 	call from_history("d1",dts)	
 	call from_history("o1",ots)
 	
 	call from_history("n2",nr)
 	call from_history("d2",dr)	
 	call from_history("o2",or) 

 	call from_history("n3",ns)
 	call from_history("d3",ds)	
 	call from_history("o3",os)
 	
 	nbytes = 4 * nr * nts

	allocate(model(nts,nr))
	allocate(data(nts,nr))	
 	
 	write(0,*) "ns",ns
 	write(0,*) "nr",nr 
 	write(0,*) "nts",nts 	
 	 	
	do is = 1,ns

		model = 0.0
		data = 0.0
		rc = sreed("in",model,nbytes)

		do ir = 1,nr

			norm = norm2(model(:,ir))	

			if (norm .gt. 0.0) then
				data(:,ir) =  model(:,ir) / norm
			end if

		end do

		wc = srite("out",data,nbytes)

	end do	 											
			
	! WRITE PARAMETERS 
	call to_history("n1",nts)
 	call to_history("d1",dts)	
 	call to_history("o1",ots)
 	
 	call to_history("n2",nr)
 	call to_history("d2",dr)	
 	call to_history("o2",or) 

 	call to_history("n3",ns)
 	call to_history("d3",ds)	
 	call to_history("o3",os)


	deallocate(model)
	deallocate(data)

 	call sep_close()

end program