module spread

	implicit none
  	integer,private                                    :: nz2,nx2

  	contains

  	subroutine spread_init(nz2_in,nx2_in)
    	integer                     :: nz2_in,nx2_in
	
		nz2 = nz2_in 
		nx2 = nx2_in

  	end subroutine

  	function spread_op(adj,add,model,data) result(stat)
    	logical,intent(in)   :: adj, add
    	real,dimension(:)    :: model,data
    	integer              :: stat
    	call spread_op2(adj,add,model,data)
    	stat=0
  	end function

  	subroutine spread_op2(adj,add,model,data)
    	logical                            :: adj,add
    	real,dimension(nz2,nx2)            :: data
    	real,dimension(1)                  :: model
    	integer                            :: iz,ix

   		if (adj) then
   		
	   		if(add .eqv. .false.) model = 0.
        	!!$OMP PARALLEL DO private(iz,ix)
			do ix = 1,nx2
				do iz = 1,nz2
					model(1) = model(1) + data(iz,ix) 
				end do
			end do
        	!!$OMP END PARALLEL DO

		else 
	   		if(add .eqv. .false.) data = 0.		
        	!!$OMP PARALLEL DO private(iz,ix)	   		
			do ix = 1,nx2
				do iz = 1,nz2
					data(iz,ix) = data(iz,ix) + model(1)
				end do
			end do
        	!!$OMP END PARALLEL DO
		end if

  	end subroutine

end module
