program spread_main

	use sep
	use spread

  	implicit none

  	integer              				:: nz,nx,nz2,nx2,z_pad,x_pad
  	real								:: dz,dx,oz,ox,oz_in,ox_in
  	real,dimension(1)					:: model
  	real,dimension(:,:),allocatable		:: data
  	logical								:: fwd

  	call sep_init()
  	
  	call from_param("fwd",fwd)

  	! if fwd spread the model value to 2d model
	if (fwd .eqv. .true.) then
	
		write(0,*) "applying forward"

		! read from the parameter file
		call from_param("nz",nz)
		call from_param("dz",dz)

		call from_param("nx",nx)
		call from_param("dx",dx)

		call from_param("z_pad",z_pad)
		call from_param("x_pad",x_pad)	
		
		call from_param("oz",oz_in,0.0)	
		call from_param("ox",ox_in,0.0)	

  		nz2 = nz + 2 * z_pad
  		nx2 = nx + 2 * x_pad
  		
 		oz = -z_pad * dz + oz_in  		
  		ox = -x_pad * dx + ox_in

		allocate(data(nz2,nx2))  	
		
 		data = 0.0  	
		call sep_read(model)
		call spread_init(nz2,nx2)
		call spread_op2(.false.,.false.,model,data)

		write(0,*) "maxval",maxval(abs(data))

		! write to output
  		call sep_write(data)		

		call to_history("n1",nz2)
		call to_history("o1",oz)
		call to_history("d1",dz)

		call to_history("n2",nx2)
		call to_history("o2",ox)
		call to_history("d2",dx)

  	! if adj stack all values to model
	else
	
		write(0,*) "applying adjoint"	
	
		call from_history("n1",nz2)
		call from_history("o1",oz)
		call from_history("d1",dz)
		
		call from_history("n2",nx2)
		call from_history("o2",ox)
		call from_history("d2",dx)
	
		model = 0.0
		allocate(data(nz2,nx2))  		
		
		call sep_read(data)
		call spread_init(nz2,nx2)		
		call spread_op2(.true.,.false.,model,data)		

		! write to output
		call sep_write(model)
		
		call to_history("n1",1)
		call to_history("o1",0.0)
		call to_history("d1",1.0)
		
		call to_history("n2",1)
		call to_history("o2",0.0)
		call to_history("d2",1.0)		

	end if
  	
  	call sep_close()

end program
