program taper_mask

	use sep
	
  	implicit none

  	integer              				:: nz,nx,iz,ix,izmin,ixmin,izmax,ixmax
  	integer								:: buffer_deep,buffer_shallow
	real								:: exp,weight
  	real,dimension(:),allocatable		:: model
  	real,dimension(:,:),allocatable     :: data

  	call sep_init()
  	
  	call from_param("nz",nz)
   	call from_param("nx",nx) 	
   	call from_param("buffer_deep",buffer_deep) 	 
   	call from_param("buffer_shallow",buffer_shallow)   	  	
   	call from_param("exp",exp) 	   	
  	
  	allocate(model(nx))
  	allocate(data(nz,nx))  	

	call sep_read(model)
	data = 0.0

	do ix=1,nx
	
		! compute bounds
		izmin = model(ix) - buffer_shallow
		izmax = model(ix) + buffer_deep
		
		! compute mask
		data(izmax:nz,ix) = 1.0
		
		do iz=izmin,izmax
			weight = 1.0 * (izmax - iz) / (izmax-izmin)
			data(iz,ix) = cos(3.14159/2.0*(weight))**exp
		end do		

	end do
  		
  	call sep_write(data)
    	
  	call to_history("n1",nz)
  	call to_history("n2",nx)
  	
  	call sep_close()

end program  		